unit Reduce;

interface

uses
  Windows, Classes, Graphics, SysUtils;

// n[tg[p 210 F̐FlB
// 6 x 7 x 5 = 210 F
const
  RedColors:   array[0..5] of Byte = (  0,  51, 102, 153, 204, 255);
  GreenColors: array[0..6] of Byte = (  0,  43,  85, 128, 171, 214, 255);
  BlueColors:  array[0..4] of Byte = (  0,  64, 128, 192, 255);

// SumsOfXXX ̐x؂ւsNZ
  MaxOctreeNodes = 100000;
// MaxOctreeNodes2 = 50000;

// qXgO̐錾B
// Cube Ƃ RGB̂ԕ64, Ε64A32
// ꍇ̃ẐƂŁACube ɂCubeɊ܂܂FF̐ώZȂ
// B 131072  3MB ̃߂B
// Cube ̔zqXgOƌĂ
  NumRed = 64; NumGreen = 64; NumBlue = 32;
  NumTotalCubes = NumRed * NumGreen * NumBlue;

var
  Palette210: HPalette;
  RLookup, GLookup, BLookup: array[0..255] of Byte;
  RI, GI, BI: Integer;
  LogPalette: TMaxLogPalette;

type
  TTriple = packed record
    B, G, R: Byte;
  end;

  TDoubleTriple = record
    B, G, R: Double;
  end;

  TTripleArray = array[0..40000000] of TTriple;
  PTripleArray = ^TTripleArray;

  TDWordArray = array[0..100000000] of DWORD;
  PDWordArray = ^TDWordArray;

  TTriples = array[-5..5] of TTriple;
  PTriples = ^TTriples;
  TTripleMatrix = array[-5..5] of PTriples;

  TFilterProc = function(x, y: Integer; Mat: TTripleMatrix;
                       pData: Pointer): TTriple;

  // FʎqNX
  TQuantizeColor = class
  public
    function GetQuantizedColor(Color: TTriple): TTriple; virtual; abstract;
  end;

  TQuantizeToStaticColor = class(TQuantizeColor)
    function GetQuantizedColor(Color: TTriple): TTriple; override;
  end;

  // 덷gUtB^pp[^R[h
  TErrorDefusionParams = record
    QuantizeColor: TQuantizeColor;
  end;
  PErrorDefusionParams = ^TErrorDefusionParams;

  TOctree = class;
  TOctreeNode = class;

  TOctreeNodeVisitor = class
  protected
    // TOctreeNode  AcceptVisitor \bhem[h
    // ĂяorW^[̃\bhłB
    // Node ͏Ώۂ̃m[hADepth ̓m[h̃gbvm[hɑ΂
    // m[h̐[\܂Bgbvm[hƂAcceptVisitor \bhO
    // m[ĥƂłA Depth  0 w肵ꍇATum[h 1A
    // ̂܂Tum[h 2 ƂɂȂ܂B
    // Continue p[^͏ True n܂BExecute 
    // False ɏƃm[h̑~܂B
    procedure Execute(Node: TOctreeNode; Delpth: Integer;
                      var Continue: Boolean); virtual; abstract;
  end;

  // TOctreeNode ͂W؂̃m[hōő8̎qm[h
  // em[hɂ͂̔zm[hɒǉꂽzSm[h̐F̑A
  //  zSm[h,,̑vĂ
  // TOctreeNode ɂ Leaf  Fork ̂QԂLB
  // Leaf: qm[hAqm[hȂm[h
  // Fork(؂̌): qm[hm[h
  // x Leaf ɂȂ Fork ɂ͂ȂȂB
  TOctreeNode = class
  private
    FIsLeaf: Boolean;
    function GetColor: TColor;           // m[h̓[t(t)
    procedure SetIsLeaf(Value: Boolean); // m[h[tɂ
  public
    Octree: TOctree;                     // m[h̑c[
    Parent: TOctreeNode;                 // em[h
    Children: array[0..7] of TOctreeNode;// qm[h
    NumPixels:   Integer;                // ̃m[hƔz̑Sm[h
                                         // ̃sNZ̑v
    SumOfRed:    Int64;                  // ̃m[hƔz̑Sm[h
                                         // Ԃ̑v
    SumOfGreen:  Int64;                  // ̃m[hƔz̑Sm[h
                                         // ΂̑v
    SumOfBlue:   Int64;                  // ̃m[hƔz̑Sm[h
                                         // ̑v
    ColorIndex:  Integer;                // ̃m[h̃J[CfbNX
                                         // c[mA[t݂̂gp
    NumSubNodes: Integer;                // qm[h̐
    NumSubLeafs:  Integer;               // qm[h̃[t̐

    constructor Create(AnOctree: TOctree; ParentNode: TOctreeNode);
    destructor Destroy; override;

    function AcceptVisitor(              // rW^[쓮
      Visitor: TOctreeNodeVisitor;
      Depth: Integer = 0): Boolean;

    // ̃m[hƔzɐF
    procedure AddColor(AColor: TTriple; Depth: Byte);

    // ̃m[hƔz̃m[hF̃J[CfbNX擾
    function GetColorIndex(AColor: TTriple; Depth: Integer): Integer;

    // m[h[tŗL邱ƂƂƂ̃m[h[tɂ̂Ɏg
    property IsLeaf: Boolean read FIsLeaf write SetIsLeaf;
    // m[h̐FvZċ߂
    property Color: TColor read GetColor;
  end;

  // Octree(W)
  TOctree = class
  private
    Root: TOctreeNode;          // [gm[h
    NumNodes: Integer;          // m[h
    NumLeafNodes: Integer;      // [t

    LogPalette: TMaxLogPalette; // _pbg̍\
    nColors: Integer;           // F

    MinPixels: Integer;         // SFork̍ŏsNZ

    // MinPixels + 0, +2, +4, +8 ȉ̃sNZȉ Fork ̐
    Num0, Num2, Num4, Num8: Integer;

    // łȃ[tł͂Ȃm[h̃sNZ߂
    procedure GetMinPixels;
    // ȃsNZ Fork 𐔂
    procedure CountSmallForkNodes;
  public
    constructor Create;
    destructor Destroy; override;

    // c[F
    procedure AddColor(AColor: TTriple);
    // FsBőF limit Ŏw肷
    procedure ReduceColors(Limit: DWORD);
    // Fpbg
    function MakePalette: HPALETTE;
    // F -> J[CfbNXϊs
    function  GetColorIndex(AColor: TTriple): Integer;
  end;

  TColorIndexVisitor = class(TOctreeNodeVisitor)
  protected
    procedure Execute(Node: TOctreeNode; Delpth: Integer;
                      var Continue: Boolean); override;
  end;

  TTrimNodeVisitor = class(TOctreeNodeVisitor)
  protected
    procedure Execute(Node: TOctreeNode; Delpth: Integer;
                      var Continue: Boolean); override;
  end;

  TGetMinForkPixels = class(TOctreeNodeVisitor)
  protected
    procedure Execute(Node: TOctreeNode; Delpth: Integer;
                      var Continue: Boolean); override;
  end;

  TCountSmallForkNodes = class(TOctreeNodeVisitor)
  protected
    procedure Execute(Node: TOctreeNode; Delpth: Integer;
                      var Continue: Boolean); override;
  end;

  TGetColorEntry = class(TOctreeNodeVisitor)
  protected
    procedure Execute(Node: TOctreeNode; Delpth: Integer;
                      var Continue: Boolean); override;
  end;

  // fBAJbg Cube
  TMedianCutCube = record
    ColorIndex:  WORD;     // ̃m[h̃J[CfbNX
    Index:       Integer;  // ̃m[h̔zCfbNX
    NumPixels:   Integer;  // CubẽsNZ̑v
    Red:         DWORD;    // Cube̐(ώZ܂͕)
    Green:       DWORD;    // Cube̗(ώZ܂͕)
    Blue:        DWORD;    // Cube̐(ώZ܂͕)
  end;

  TRGBHistogram = array[0..NumRed-1, 0..NumGreen-1, 0..NumBlue-1]
                  of TMedianCutCube;
  PRGBHistogram = ^TRGBHistogram;
  THistogram    = array[0..NumTotalCubes-1]of TMedianCutCube;
  PHistogram    = ^THistogram;

  // RGBQuad ̔z
  TRGBQuadArray    = array[0..255] of TRGBQuad;
  PRGBQuadArray    = ^TRGBQuadArray;

  // fBAJbg NX
  TMedianCut = class
  private
    FHistogram: PRGBHistogram;
    FColorConvertTable: array[0..NumTotalCubes-1] of Byte;
    FNumColors: Integer;   // oF
    FColors: TRGBQuadArray;

    // qXgO𕪊(ӂ̒ŕ)
    procedure CutCubes(Low,        // Color Cube Q̍ŏ Cube w
                                   // CfbNX
                       High,       // Color Cube Q̍Ō̎ Cube w
                                   //CfbNX
                       Depth,      // ̐[
                       MaxDepth: LongInt;     // ̐[̍ől
                       var Cubes: THistogram; // Color Cube z
                       var Colors: TRGBQuadArray; // FJ[o͗p
                                                  // J[e[u
                       var NumColors: LongInt);   // o͂ꂽFJ[F̐

    // qXgO𕪊
    procedure CutCubesByVariance(
                       Low,        // Color Cube Q̍ŏ Cube w
                                   // CfbNX
                       High,       // Color Cube Q̍Ō̎ Cube w
                                   //CfbNX
                       Depth,                 // ̐[
                       MaxDepth: LongInt;     // ̐[̍ől
                       var Cubes: THistogram; // Color Cube z
                       var Colors: TRGBQuadArray; // FJ[o͗p
                                                  // J[e[u
                       var NumColors: LongInt);   // o͂ꂽFJ[F̐

  public
    constructor Create;
    destructor  Destroy; override;

    //qXgOɐF
    procedure AddColor(AColor: TTriple);


    // FBqXgO͕̕ӂ̒pB
    // ShrinkCubes ̓qXgO̒̃sNZȂCube
    // ȂƂw肷BȂꍇAꂽqXgO
    // g F -> J[e[uCfbNXꍇAqXgO
    // ܂܂ȂF͕ϊłȂB
    procedure ReduceColors(MaxDepth: Integer; ShrinkCubes: Boolean);
    // FBqXgO͕̕UpB
    // ShrinkCubes ̓qXgO̒̃sNZȂCube
    // ȂƂw肷BȂꍇAꂽqXgO
    // g F -> J[e[uCfbNXꍇAqXgO
    // ܂܂ȂF͕ϊłȂB
    procedure ReduceColorsByVariance(MaxDepth: Integer; ShrinkCubes: Boolean);

    // ꂽqXgOpbg
    function MakePalette: HPALETTE;

    // F -> J[e[uCfbNXϊsB
    //  ShrinkCubes ̐ɒ
    function GetColorIndex(Color: TTriple): Integer;
  end;

  // J[ -> J[CfbNXϊe[up̔z^
  T3DByteArray = array[0..63, 0..63, 0..31] of Byte;
  P3DByteArray = ^T3DByteArray;

  TMedianCutQuantizeColor = class(TQuantizeColor)
  private
    FMediancut: TMedianCut;
    ColorTable: array[0..255] of TPaletteEntry;
  public
    constructor Create(AMedianCut: TMedianCut);
    function GetQuantizedColor(Color: TTriple): TTriple; override;
  end;

// tB^
function BitmapFilter(Bitmap: TBitmap; Filter: TFilterProc;
                      pData: Pointer): TBitmap;

function ErrorDefusion(Bitmap: TBitmap;
                       QuantizeColor: TQuantizeColor): TBitmap;

function StaticErrorDefusion(Bitmap: TBitmap): TBitmap;

function ReduceColorsByOctree(Bitmap: TBitmap; Limit: Integer): TBitmap;

// F(ӂ̒łŕ)
function ReduceColorsByMedianCut(Bitmap: TBitmap; Depth: Integer): TBitmap;

// F(Uŕ)
function ReduceColorsByMedianCutV(Bitmap: TBitmap; Depth: Integer): TBitmap;

// F(ӂ̒ŕ{덷gU)
function ReduceColorsByMedianCutED(Bitmap: TBitmap; Depth: Integer): TBitmap;

// F(Uŕ{덷gU)
function ReduceColorsByMedianCutVED(Bitmap: TBitmap; Depth: Integer): TBitmap;

implementation

function BitmapFilter(Bitmap: TBitmap; Filter: TFilterProc;
                      pData: Pointer): TBitmap;
var MatSave,            // 11CScanlineێobt@
    Mat: TTripleMatrix; // sNZ󂯎 11x11 ̃}gbNX
    i: Integer;
    x, y: Integer;               // W
    NewBitmap: TBitmap;          // 쐬rbg}bv
    DestLine: PTripleArray;      // Vrbg}bṽXLC
    LineSize, BufSize: Integer;  // sTCYƃobt@TCY
begin
  // BitmapFilter  24bpp T|[g܂B
  if Bitmap.PixelFormat <> Pf24Bit then
    Raise Exception.Create('BitmapFiletr accepts only 24Bit DIB');

  // PCsNZf[^ێ邽߂̃obt@vZ܂B
  // 10Ă̂́A}gbNXrbg}bv͂ݏoƂ
  // lĂ邩łB
  BufSize := (Bitmap.Width + 10) * 3;
  LineSize := Bitmap.Width * 3;

  // }gbNXNA
  FillChar(Mat, SizeOf(Mat), 0);

  // Vrbg}bv
  NewBitmap := TBitmap.Create;
  try
    NewBitmap.Width := Bitmap.Width; NewBitmap.Height := Bitmap.Height;
    NewBitmap.PixelFormat := pf24bit;

    try
      // MatSvae 쐬BMaSave̓rbg}bv11C
      // XLCێBMatSave ̊es rbg}bv̕+10
      // sNZ̑傫ŁA6sNZڂrbg}bv
      // XLCRs[B܂O5sNZ͏ɂOɂȂ
      // MatSave[0][0] 6Cڂ6sNZڂANZX邱ƂɂȂB
      for i := -5 to 5 do MatSave[i] := Nil;
      for i:= -5 to 5  do begin
        GetMem(MatSave[i], BufSize);
        FillChar(MatSave[i]^, BufSize, 0);
        if (i < 0) or (i >= Bitmap.Height) then begin
        end
        else begin
          System.Move(Bitmap.ScanLine[i]^, MatSave[i][0], LineSize);
        end;
      end;

      for y := 0 to Bitmap.Height-1 do begin
        DestLine := NewBitmap.Scanline[y];
        Mat := MatSave;
        for x := 0 to Bitmap.Width-1 do begin
          // tB^̉ZĂ
          DestLine[x] := Filter(x, y, Mat, pData);
          // }gbNX̍s|C^PsNZ炷
          for i := -5 to 5 do Mat[i] := PTriples(LongInt(Mat[i])+3);
        end;

        // MatSave ̓e1sɃXN[
        FreeMem(MatSave[-5]);
        MatSave[-5] := Nil;

        for i := -5 to 4 do MatSave[i] := MatSave[i+1];
        MatSave[5] := Nil;

        //ŉsɌ̃rbg}bvXLCǂݍ
        GetMem(MatSave[5], BufSize);
        FillChar(MatSave[5]^, BufSize, 0);

        if y + 6 < Bitmap.Height then begin
          System.Move(Bitmap.ScanLine[y+6]^, MatSave[5][0], LineSize);
        end;
      end;
    finally
      for i := -5 to 5 do
        if MatSave[i] <> Nil then
          FreeMem(MatSave[i]);
    end;
  except
    NewBitmap.Free;
    raise;
  end;

  Result := NewBitmap;
end;

// 덷gUtB^(Floyd-SteinbergtB^)
function ErrorDefusionFilterProc(x, y: Integer; Mat: TTripleMatrix;
                                 pData: Pointer): TTriple;
var
  pParams: PErrorDefusionParams;
  QuantizedColor: TTriple;          // œKJ[
  RError, GError, BError: Integer;  // œKJ[̌덷

  function LimitValue(Value: Integer): Integer;
  begin
    Result := Value;
    if Result < 0 then Result := 0;
    if Result > 255 then Result := 255;
  end;
begin
  pParams := pData;

  // œKJ[߂
  QuantizedColor := pParams.QuantizeColor.GetQuantizedColor(Mat[0][0]);

  // œKJ[̌덷߂
  RError := QuantizedColor.r   - Mat[0][0].r;
  GError := QuantizedColor.g - Mat[0][0].g;
  BError := QuantizedColor.b  - Mat[0][0].b;

  // ߂l := œKJ[
  Result := QuantizedColor;

  // 덷gU(Floyd-Steinberg)
  Mat[ 0][ 1].r := LimitValue(Mat[ 0][ 1].r - RError * 7 div 16);
  Mat[ 0][ 1].g := LimitValue(Mat[ 0][ 1].g - GError * 7 div 16);
  Mat[ 0][ 1].b := LimitValue(Mat[ 0][ 1].b - BError * 7 div 16);

  Mat[ 1][-1].r := LimitValue(Mat[ 1][-1].r - RError * 3 div 16);
  Mat[ 1][-1].g := LimitValue(Mat[ 1][-1].g - GError * 3 div 16);
  Mat[ 1][-1].b := LimitValue(Mat[ 1][-1].b - BError * 3 div 16);

  Mat[ 1][ 0].r := LimitValue(Mat[ 1][ 0].r - RError * 5 div 16);
  Mat[ 1][ 0].g := LimitValue(Mat[ 1][ 0].g - GError * 5 div 16);
  Mat[ 1][ 0].b := LimitValue(Mat[ 1][ 0].b - BError * 5 div 16);

  Mat[ 1][ 1].r := LimitValue(Mat[ 1][ 1].r - RError * 1 div 16);
  Mat[ 1][ 1].g := LimitValue(Mat[ 1][ 1].g - GError * 1 div 16);
  Mat[ 1][ 1].b := LimitValue(Mat[ 1][ 1].b - BError * 1 div 16);
end;

function ErrorDefusion(Bitmap: TBitmap;
                       QuantizeColor: TQuantizeColor): TBitmap;
var
  Params: TErrorDefusionParams;
begin
  Params.QuantizeColor := QuantizeColor;
  Result := BitmapFilter(Bitmap, ErrorDefusionFilterProc,  @Params);
end;

function StaticErrorDefusion(Bitmap: TBitmap): TBitmap;
var
  QuantizeColor: TQuantizeToStaticColor; // ʎqNX
  NewBitmap, NewBitmap2: TBitmap;
  x, y: Integer;                     // W
  SourceScan: PTripleArray;          // Vrbg}bv Scanline
  DestScan: PByteArray;
  Color: TTriple;                    // ϊƂ̐F
begin
  Result := Nil;
  QuantizeColor := TQuanTizeToStaticColor.Create;
  try
    NewBitmap := ErrorDefusion(Bitmap, QuantizeColor);
    try
      //V8bpp̃rbg}bv̍쐬
      NewBitmap2 := TBitmap.Create;
      try
        NewBitmap2.PixelFormat := pf8bit;
        NewBitmap2.Width := Bitmap.Width;
        NewBitmap2.Height := Bitmap.Height;
        NewBitmap2.Palette := CopyPalette(Palette210); // Œpbg

        // Fϊ̃[v
        for y := 0 to Bitmap.Height-1 do
        begin
          SourceScan := NewBitmap.Scanline[y];
          DestScan := NewBitmap2.Scanline[y];
          for x := 0 to Bitmap.Width-1 do begin
            Color := SourceScan[x];
            DestScan[x] := RLookup[Color.R] * 7*5 + GLookup[Color.G] * 5 +
                           BLookup[Color.B];
          end;
        end;
        Result := NewBitmap2;
      except
        NewBitmap2.Free;
        raise;
      end;
    finally
      NewBitmap.Free;
    end;
  finally
    QuantizeColor.Free;
  end;
end;

// F
function ReduceColorsByOctree(Bitmap: TBitmap; Limit: Integer): TBitmap;
var
  NewBitmap: TBitmap;       // Vrbg}bv
  Octree: TOctree;          // W
  x, y: Integer;            // W
  SourceScan: PTripleArray; // Vrbg}bv Scanline
  DestScan: PByteArray;
  Color: TTriple;           // F
begin
  Result := Nil;
  Assert((2<= Limit) and (Limit <= 256));
  Assert(Bitmap.PixelFormat = pf24bit);

  Octree := TOctree.Create;  // Octree 쐬
  try
    // Octree ̍\z
    for y := 0 to Bitmap.Height-1 do
    begin
      SourceScan := Bitmap.Scanline[y];
      for x := 0 to Bitmap.Width-1 do
      begin
        Color := SourceScan[x];
        Octree.AddColor(Color);
      end;
    end;
    Octree.ReduceColors(Limit);    // 256FȉɌF

    //Vrbg}bv̍쐬
    NewBitmap := TBitmap.Create;
    try
      NewBitmap.PixelFormat := pf8bit;
      NewBitmap.Width := Bitmap.Width;
      NewBitmap.Height := Bitmap.Height;
      NewBitmap.Palette := Octree.MakePalette; // Fꂽpbg

      // Fϊ̃[v
      for y := 0 to Bitmap.Height-1 do
      begin
        SourceScan := Bitmap.Scanline[y];
        DestScan := NewBitmap.Scanline[y];
        for x := 0 to Bitmap.Width-1 do
        begin
          // Octree  GetColorIndex  24bit Color  pbg
          // Ggԍɕϊ
          DestScan[x] := Octree.GetColorIndex(SourceScan[x]);
        end;
      end;
      Result := NewBitmap;
    except
      NewBitmap.Free;
      raise;
    end;
  finally
    Octree.Free;
  end;
end;

// F(ӂ̒łŕ)
function ReduceColorsByMedianCut(Bitmap: TBitmap; Depth: Integer)
  : TBitmap;
var
  NewBitmap: TBitmap;       // Vrbg}bv
  MedianCut: TMedianCut;    // fBAJbg
  x, y: Integer;            // W
  SourceScan: PTripleArray; // Vrbg}bv Scanline
  DestScan: PByteArray;
begin
  Result := Nil;
  Assert(Depth >= 0);
  Assert(Bitmap.PixelFormat = pf24bit);

  MedianCut := TMedianCut.Create;  // MedianCut 쐬
  try
    // qXgO ̍\z
    for y := 0 to Bitmap.Height-1 do
    begin
      SourceScan := Bitmap.Scanline[y];
      for x := 0 to Bitmap.Width-1 do
        MedianCut.AddColor(SourceScan[x]);
    end;

    // FB덷gÛŁA̗ǂ ShrinCubes = True g
    MedianCut.ReduceColors(Depth, True);    // F

    //V 8bpp ̃rbg}bv̍쐬
    NewBitmap := TBitmap.Create;
    try
      NewBitmap.PixelFormat := pf8bit;
      NewBitmap.Width := Bitmap.Width;
      NewBitmap.Height := Bitmap.Height;
      NewBitmap.Palette := MedianCut.MakePalette; // Fꂽpbg

      // Fϊ̃[v
      for y := 0 to Bitmap.Height-1 do
      begin
        SourceScan := Bitmap.Scanline[y];
        DestScan := NewBitmap.Scanline[y];
        for x := 0 to Bitmap.Width-1 do
        begin
          // MedianCut  GetColorIndex  24bit Color  pbg
          // Ggԍɕϊ
          DestScan[x] := MedianCut.GetColorIndex(SourceScan[x]);
        end;
      end;
      Result := NewBitmap;
    except
      NewBitmap.Free;
      raise;
    end;
  finally
    MedianCut.Free;
  end;
end;

// F(Uŕ)
function ReduceColorsByMedianCutV(Bitmap: TBitmap; Depth: Integer)
  : TBitmap;
var
  NewBitmap: TBitmap;       // Vrbg}bv
  MedianCut: TMedianCut;    // fBAJbg
  x, y: Integer;            // W
  SourceScan: PTripleArray; // Vrbg}bv Scanline
  DestScan: PByteArray;
begin
  Result := Nil;
  Assert(Depth >= 0);
  Assert(Bitmap.PixelFormat = pf24bit);

  MedianCut := TMedianCut.Create;  // MedianCut 쐬
  try
    // qXgO ̍\z
    for y := 0 to Bitmap.Height-1 do
    begin
      SourceScan := Bitmap.Scanline[y];
      for x := 0 to Bitmap.Width-1 do
        MedianCut.AddColor(SourceScan[x]);
    end;

    // UŃfBAJbgB
    // 덷gUȂ̂Ō̗ǂ ShrinkCubes=True g
    MedianCut.ReduceColorsByVariance(Depth, True);    // 256FȉɌF

    //V8bpp̃rbg}bv̍쐬
    NewBitmap := TBitmap.Create;
    try
      NewBitmap.PixelFormat := pf8bit;
      NewBitmap.Width := Bitmap.Width;
      NewBitmap.Height := Bitmap.Height;
      NewBitmap.Palette := MedianCut.MakePalette; // Fꂽpbg

      // Fϊ̃[v
      for y := 0 to Bitmap.Height-1 do
      begin
        SourceScan := Bitmap.Scanline[y];
        DestScan := NewBitmap.Scanline[y];
        for x := 0 to Bitmap.Width-1 do
        begin
          // MedianCut  GetColorIndex  24bit Color  pbg
          // Ggԍɕϊ
          DestScan[x] := MedianCut.GetColorIndex(SourceScan[x]);
        end;
      end;
      Result := NewBitmap;
    except
      NewBitmap.Free;
      raise;
    end;
  finally
    MedianCut.Free;
  end;
end;

// F(ӂ̒ŕ{덷gU)
function ReduceColorsByMedianCutED(Bitmap: TBitmap;
                                   Depth: Integer): TBitmap;
var
  NewBitmap, NewBitmap2: TBitmap; // Vrbg}bv
  MedianCut: TMedianCut;          // fBAJbg
  x, y: Integer;                  // W
  SourceScan: PTripleArray;       // Vrbg}bv Scanline
  DestScan: PByteArray;
  QuantizeColor: TMedianCutQuantizeColor; // FʎqNX
begin
  Result := Nil;
  Assert(Depth >= 0);
  Assert(Bitmap.PixelFormat = pf24bit);

  MedianCut := TMedianCut.Create;  // MedianCut 쐬
  try
    // MedianCut ̍\z
    for y := 0 to Bitmap.Height-1 do
    begin
      SourceScan := Bitmap.Scanline[y];
      for x := 0 to Bitmap.Width-1 do
        MedianCut.AddColor(SourceScan[x]);
    end;

    // 덷gUł͊gUł낢ȐF̂
    // SĂ Cube ȂƐF̃CfbNXւ̕ϊłȂȂ
    MedianCut.ReduceColors(Depth, False);    // 256FȉɌF

    // 덷gU
    QuantizeColor := TMedianCutQuantizeColor.Create(MedianCut);
    try
      NewBitmap := ErrorDefusion(Bitmap, QuantizeColor);
    finally
      QuantizeColor.Free;
    end;

    try
      //V8bpp̃rbg}bv̍쐬
      NewBitmap2 := TBitmap.Create;
      try
        NewBitmap2.PixelFormat := pf8bit;
        NewBitmap2.Width := Bitmap.Width;
        NewBitmap2.Height := Bitmap.Height;
        NewBitmap2.Palette := MedianCut.MakePalette; // Fꂽpbg

        // Fϊ̃[v
        for y := 0 to Bitmap.Height-1 do
        begin
          SourceScan := NewBitmap.Scanline[y];
          DestScan := NewBitmap2.Scanline[y];
          for x := 0 to Bitmap.Width-1 do
            // GetColorIndex  24bit Color  pbg
            // Ggԍɕϊ
            DestScan[x] := MedianCut.GetColorIndex(SourceScan[x]);
        end;
        Result := NewBitmap2;
      except
        NewBitmap2.Free;
        raise;
      end;
    finally
      NewBitmap.Free;
    end;
  finally
    MedianCut.Free;
  end;
end;

// F(Uŕ{덷gU)
function ReduceColorsByMedianCutVED(Bitmap: TBitmap;
                                    Depth: Integer): TBitmap;
var
  NewBitmap, NewBitmap2: TBitmap; // Vrbg}bv
  MedianCut: TMedianCut;          // fBAJbg
  x, y: Integer;                  // W
  SourceScan: PTripleArray;       // Vrbg}bv Scanline
  DestScan: PByteArray;
  QuantizeColor: TMedianCutQuantizeColor; // FʎqNX
begin
  Result := Nil;
  Assert(Depth >= 0);
  Assert(Bitmap.PixelFormat = pf24bit);

  MedianCut := TMedianCut.Create;  // MedianCut 쐬
  try
    // MedianCut ̍\z
    for y := 0 to Bitmap.Height-1 do
    begin
      SourceScan := Bitmap.Scanline[y];
      for x := 0 to Bitmap.Width-1 do
        MedianCut.AddColor(SourceScan[x]);
    end;
    // 덷gUł͊gUł낢ȐF̂
    // SĂ Cube ȂƐF̃CfbNXւ̕ϊłȂȂ
    MedianCut.ReduceColorsByVariance(Depth, False);    // 256FȉɌF

    // 덷gU
    // 덷gU
    QuantizeColor := TMedianCutQuantizeColor.Create(MedianCut);
    try
      NewBitmap := ErrorDefusion(Bitmap, QuantizeColor);
    finally
      QuantizeColor.Free;
    end;

    try
      //V8bpp̃rbg}bv̍쐬
      NewBitmap2 := TBitmap.Create;
      try
        NewBitmap2.PixelFormat := pf8bit;
        NewBitmap2.Width := Bitmap.Width;
        NewBitmap2.Height := Bitmap.Height;
        NewBitmap2.Palette := MedianCut.MakePalette; // Fꂽpbg

        // Fϊ̃[v
        for y := 0 to Bitmap.Height-1 do
        begin
          SourceScan := NewBitmap.Scanline[y];
          DestScan := NewBitmap2.Scanline[y];
          for x := 0 to Bitmap.Width-1 do
            // GetColorIndex  24bit Color  pbg
            // Ggԍɕϊ
            DestScan[x] := MedianCut.GetColorIndex(SourceScan[x]);
        end;
        Result := NewBitmap2;
      except
        NewBitmap2.Free;
        raise;
      end;
    finally
      NewBitmap.Free;
    end;
  finally
    MedianCut.Free;
  end;
end;

{ TQuantizeToStaticColor }
function TQuantizeToStaticColor.GetQuantizedColor(Color: TTriple): TTriple;
begin
  Result.R := RedColors[RLookup[Color.R]];
  Result.G := GreenColors[GLookup[Color.G]];
  Result.B := BlueColors[BLookup[Color.B]];
end;

{ TOctreeNode }
// m[hւ̐F̒ǉ
procedure TOctreeNode.AddColor(AColor: TTriple; Depth: Byte);
var
  Mask: Byte;      // qm[hԍZo邽߂̐F̃}XN
  NodeIndex: Byte; // qm[hԍ
begin
  // m[hɐF(sNZ)ǉ
  Inc(NumPixels);
  Inc(SumOfRed, AColor.r);
  Inc(SumOfGreen, AColor.g);
  Inc(SumOfBlue, AColor.b);
  if IsLeaf then Exit;  // [tȂqm[h͖AȂ

  // qm[hԍZo
  Mask := $80 shr Depth;
  NodeIndex := 0;
  if (Mask and AColor.r) <> 0 then Inc(NodeIndex, 4);
  if (Mask and AColor.g) <> 0 then Inc(NodeIndex, 2);
  if (Mask and AColor.b) <> 0 then Inc(NodeIndex, 1);

  // qm[h΍
  if Children[NodeIndex] = Nil then
  begin
    Children[NodeIndex] := TOctreeNode.Create(Octree, Self);

    // Octree ̐[5xɗ}
    if Depth = 5 then
      Children[NodeIndex].IsLeaf := True;

  end;
  // ʃm[hɂF
  Children[NodeIndex].AddColor(AColor, Depth+1);
end;

// RXgN^
constructor TOctreeNode.Create(AnOctree: TOctree; ParentNode: TOctreeNode);
begin
  // ؂ƐeZbg
  Octree := AnOctree;
  Parent := ParentNode;
  //؂̃m[h𑝂₷
  Inc(Octree.NumNodes);
  //ẽm[h𑝂₷
  if Parent <> Nil then
  begin
    Inc(Parent.NumSubNodes);
  end;
end;

destructor TOctreeNode.Destroy;
var
  i: Integer;
begin
  // ؂̃m[h炷
  Dec(Octree.NumNodes);
  // [tȂ؂̃[t炷
  if IsLeaf then Dec(Octree.NumLeafNodes);

  if Parent <> Nil then
  begin
    // ẽm[h炷
    Dec(Parent.NumSubNodes);
    // [tȂẽ[t炷
    if IsLeaf then Dec(Parent.NumSubLeafs);
  end;

  // gz̃m[hj
  for i := 0 to 7 do Children[i].Free;

  inherited;
end;

// m[h̐FZo
function TOctreeNode.GetColor: TColor;
begin
  if NumPixels > 0 then
  begin
    Result := RGB(SumOfRed   div NumPixels,
                  SumOfGreen div NumPixels,
                  SumOfBlue  div NumPixels);
  end
  else
    Result := RGB(0, 0, 0);
end;

// m[h[tɂ
procedure TOctreeNode.SetIsLeaf(Value: Boolean);
begin
  FIsLeaf := Value;
  if Value = True then
  begin
    // ؂Ɛẽ[t𑝂₷
    Inc(Octree.NumLeafNodes);
    if Parent <> Nil then Inc(Parent.NumSubLeafs);
  end;
end;

// F->J[CfbNXϊ
function TOctreeNode.GetColorIndex(AColor: TTriple;
  Depth: Integer): Integer;
var
  NodeIndex: Integer;
  Mask: Byte;
begin
  // [tȂ玩gJ[CfbNXĂ̂
  // Ԃ
  if IsLeaf then Result := ColorIndex
  else
  begin
    // Fqm[h̃CfbNXZo

    Mask := $80 shr Depth;

    NodeIndex := 0;
    if (AColor.r and Mask) <> 0 then Inc(NodeIndex, 4);
    if (AColor.g and Mask) <> 0 then Inc(NodeIndex, 2);
    if (AColor.b and Mask) <> 0 then Inc(NodeIndex, 1);

    // qm[hɏ
    Result := Children[NodeIndex].GetColorIndex(AColor, Depth+1);
  end;
end;

// rW^[̋쓮BgƔzm[hɃBW^[Kp
function TOctreeNode.AcceptVisitor(Visitor: TOctreeNodeVisitor;
  Depth: Integer): Boolean;
var i: Integer;
begin
  // ʃm[hɑ΂čċAI Visitor Ă
  for i := 0 to 7 do
    if Children[i] <> Nil then
    begin
      Result := Children[i].AcceptVisitor(Visitor, Depth+1);
      if not Result then Exit;
    end;

  Result := True;
  // m[hɑ΂ Visitor Ă
  Visitor.Execute(Self, Depth, Result);

  if not Result then Exit;

end;

{ TOctree }
// ؂ɐFǉ
procedure TOctree.AddColor(AColor: TTriple);
var
  Visitor: TTrimNodeVisitor;
begin
  Root.AddColor(AColor, 0);

  // m[ȟzꍇAm[h
  if NumNodes > MaxOctreeNodes then
  begin
    MinPixels := 1; // m[hׂŒsNZ-1
                    // ȉm[h
    Visitor := TTrimNodeVisitor.Create;
    try
      while NumNodes > MaxOctreeNodes - 1000 do
      begin
        // m[hrW^[Ăяo
        Root.AcceptVisitor(Visitor);
        Inc(MinPixels); // m[h肫Ȃꍇ͊l𑝂₷
      end;
    finally
      Visitor.Free;
    end;
  end;
end;

// l(MinPixels)gďȃsNZ Fork
// ̐𐔂BF̉Ɏg
procedure TOctree.CountSmallForkNodes;
var
  Visitor: TCountSmallForkNodes;
begin
  // Num0: MinPixels ȉ̐
  // Num2: MinPixels + 2 ȉ̐
  // Num4: MinPixels + 4 ȉ̐
  // Num8: MinPixels + 8 ȉ̐
  Num0 := 0;Num2 := 0; Num4 := 0; Num8 := 0;
  Visitor := TCountSmallForkNodes.Create;
  try
    Root.AcceptVisitor(Visitor);
  finally
    Visitor.Free;
  end;
end;

// RXgN^ [g邾
constructor TOctree.Create;
begin
  Root := TOctreeNode.Create(Self, Nil);
end;

// fXgN^
destructor TOctree.Destroy;
begin
  // Sm[hj
  Root.Free;
  inherited;
end;

// F -> J[CfbNXϊ
function TOctree.GetColorIndex(AColor: TTriple): Integer;
begin
  Result := Root.GetColorIndex(AColor, 0);
end;

// SFork ̍łsNZ߂
procedure TOctree.GetMinPixels;
var
  Visitor: TGetMinForkPixels;
begin
  MinPixels := 999999999;
  Visitor := TGetMinForkPixels.Create;
  try
    Root.AcceptVisitor(Visitor);
  finally
    Visitor.Free;
  end;
end;

// SẴ[t_pbg쐬
function TOctree.MakePalette: HPALETTE;
var
  Visitor: TGetColorEntry;
begin
  nColors := 0;
  LogPalette.palVersion := $0300;
  LogPalette.palNumEntries := NumLeafNodes;

  // rW^[NALogPalette ̃J[Gg擾
  Visitor := TGetColorEntry.Create;
  try
    Root.AcceptVisitor(Visitor);
  finally
    Visitor.Free;
  end;

  // pbg
  Result := CreatePalette(PLogPalette(@LogPalette)^);
end;

// F Limit͍őF
procedure TOctree.ReduceColors(Limit: DWORD);
var
  Visitor: TOctreeNodeVisitor;
begin
  MinPixels := 1;  // Fork ׂsNZ̍Œl -1

  Visitor := TTrimNodeVisitor.Create;
  try
    // [t̐(FꂽF) LimitȉɂȂ܂Ńm[h
    while NumLeafNodes > Integer(Limit) do
    begin
      // m[h邽߂̃rW^[N
      Root.AcceptVisitor(Visitor);
      GetMinPixels;        // Fork ̍ŏsNZ߂
      CountSmallForkNodes; // l(MinPixels) +0, +2, +4, +8 ȉ
                           // (Fork̎qm[h-1)̑a߂
      // m[ȟۗ\lÅl߂()
      if Num8 < NumNodes - Integer(Limit) then
        Inc(MinPixels, 8)
      else if Num4 < NumNodes - Integer(Limit) then
        Inc(MinPixels, 4)
      else if Num2 < NumNodes - Integer(Limit) then
        Inc(MinPixels, 2)
    end;
  finally
    Visitor.Free;
  end;

  // m肵[tɃJ[CfbNXt
  nColors := 0;
  Visitor := TColorIndexVisitor.Create;
  try
    Root.AcceptVisitor(Visitor);
  finally
    Visitor.Free;
  end;
end;

//////////////////
//
// ̓rW^[̏
//

{ TColorIndexVisitor }
// m[hɃJ[CfbNXt
// Octree.nColorIndex ͎gŏ邱
procedure TColorIndexVisitor.Execute(Node: TOctreeNode; Delpth: Integer;
  var Continue: Boolean);
begin
  if Node.IsLeaf then
  begin
    Node.ColorIndex := Node.Octree.nColors;
    Inc(Node.Octree.nColors);
  end
end;

{ TTrimNodeVisitor }
// m[hBOctree ̍łdvȏ
procedure TTrimNodeVisitor.Execute(Node: TOctreeNode; Delpth: Integer;
  var Continue: Boolean);
var
  i: Integer;
begin
  if Node.IsLeaf then Exit; // [tȂ牽Ȃ

  //[tlȉȂŎqm[hSă[tȂ烊[t
  if Node.NumPixels <= Node.Octree.MinPixels then
  begin
    if Node.NumSubNodes = Node.NumSubLeafs then
    begin
      for i := 0 to 7 do
      begin
        if Node.Children[i] <> Nil then Node.Children[i].Free;
        Node.Children[i] := Nil;
      end;
      // [t玩[tɂȂ(dv)
      Node.IsLeaf := True;
    end;
  end;
end;

{ TGetMinForkPixels }
// ̃m[h̍Œ̃sNZ߂
procedure TGetMinForkPixels.Execute(Node: TOctreeNode; Delpth: Integer;
  var Continue: Boolean);
begin
  if Node.IsLeaf then Exit;

  // qm[hSă[t̂̂ōŏ̃sNZI
  if Node.NumSubNodes = Node.NumSubLeafs then
    if Node.NumPixels < Node.Octree.MinPixels then
      Node.Octree.MinPixels := Node.NumPixels;
end;

{ TCountSmallForkNodes }
// l +0, +2, +4, +8 ꍇ̊m[h
// \lvZ(Ȃ葽ڂ̌vZlɂȂ)
procedure TCountSmallForkNodes.Execute(Node: TOctreeNode; Delpth: Integer;
  var Continue: Boolean);
begin
  if Node.IsLeaf then Exit;

  if Node.NumPixels <= Node.Octree.MinPixels then
    Inc(Node.Octree.Num0, Node.NumPixels-1);
  if Node.NumPixels <= Node.Octree.MinPixels + 2   then
    Inc(Node.Octree.Num2, Node.NumPixels-1);
  if Node.NumPixels <= Node.Octree.MinPixels + 4  then
    Inc(Node.Octree.Num4, Node.NumPixels-1);
  if Node.NumPixels <= Node.Octree.MinPixels + 8 then
    Inc(Node.Octree.Num8, Node.NumPixels-1);
end;

{ TGetColorEntry }
// [t̐FpbgGgɓ
// Octree.nColors ͎gŏ
procedure TGetColorEntry.Execute(Node: TOctreeNode; Delpth: Integer;
  var Continue: Boolean);
begin
  if Node.IsLeaf then
  begin
    Node.Octree.LogPalette.palPalEntry[Node.Octree.nColors].peRed :=
      GetRValue(Node.Color);
    Node.Octree.LogPalette.palPalEntry[Node.Octree.nColors].peGreen :=
      GetGValue(Node.Color);
    Node.Octree.LogPalette.palPalEntry[Node.Octree.nColors].peBlue :=
      GetBValue(Node.Color);
    Node.Octree.LogPalette.palPalEntry[Node.Octree.nColors].peFlags := 0;
    Inc(Node.Octree.nColors);
  end
end;

{ TMedianCutQuantizeColor }
constructor TMedianCutQuantizeColor.Create(AMedianCut: TMedianCut);
var
  Palette: HPALETTE;
begin
  FMedianCut := AMedianCut;
  Palette := AMedianCut.MakePalette;
  try
    GetPaletteEntries(Palette, 0, 256, ColorTable);
  finally
    DeleteObject(Palette);
  end;
end;

function TMedianCutQuantizeColor.GetQuantizedColor(Color: TTriple): TTriple;
var
  Index: Integer;
  PalEntry: TPaletteEntry;
begin
  Index := FMedianCut.GetColorIndex(Color);
  PalEntry := ColorTable[Index];
  Result.R := PalEntry.peRed;
  Result.G := PalEntry.peGreen;
  Result.B := PalEntry.peBlue;
end;

{ TMedianCut }
// qXgO\z
procedure TMedianCut.AddColor(AColor: TTriple);
var
  ri, gi, bi: Integer;
begin
  ri := AColor.r shr 2; gi := AColor.g shr 2; bi := AColor.b shr 3;
  Inc(FHistogram[ri, gi, bi].NumPixels);

  // (ri, gi, bi) ̎Fɑ΂鍷𑫂
  // 邱Ƃ 32bit ŐF[ɐώZłB
  // 4G div 7 = 585M Pixel܂őv
  Inc(FHistogram[ri, gi, bi].Red,   AColor.r and $03);
  Inc(FHistogram[ri, gi, bi].Green, AColor.g and $03);
  Inc(FHistogram[ri, gi, bi].Blue,  AColor.b and $07);
end;

constructor TMedianCut.Create;
var
  i: Integer;
begin
  FHistogram := AllocMem(SizeOf(TRGBHistogram));
  for i := 0 to NumTotalCubes-1 do
  begin
    PHistogram(FHistogram)[i].Index := i;
  end;
end;

// qXgOӂ̒ōċAIɕ
procedure TMedianCut.CutCubes(Low, High, Depth, MaxDepth: Integer;
  var Cubes: THistogram; var Colors: TRGBQuadArray;
  var NumColors: Integer);
var
  i, j, NumPixels: LongInt;
  RAve, GAve, BAve: Int64;                   // ԁA΁A̕ϒl
  R, G, B: Byte;
  RMin, RMax, GMin, GMax, BMin, BMax: Byte;  // ԁA΁A̍őAŏl
  temp: TMedianCutCube;
begin
   // Low = High ł Cube Q Cube ĂȂB
  if Low = High then Exit;

  // Cube Q̐F̕ςƕUvZ
  RAve := 0; GAve := 0; BAve := 0;
  RMin := 255; RMax := 0;
  GMin := 255; GMax := 0;
  BMin := 255; BMax := 0;
  NumPixels := 0;

  for i := Low to High-1 do begin
    Inc(NumPixels, Cubes[i].NumPixels);  // sNZ̑JEg

    R := Cubes[i].Red;
    G := Cubes[i].Green;
    B := Cubes[i].Blue;

    // eF̍ő^ŏ߂
    if R < RMin then RMin := R;
    if G < GMin then GMin := G;
    if B < BMin then BMin := B;

    if R > RMax then RMax := R;
    if G > GMax then GMax := G;
    if B > BMax then BMax := B;

    // eFώZ
    RAve := RAve + R * Cubes[i].NumPixels;
    GAve := GAve + G * Cubes[i].NumPixels;
    BAve := BAve + B * Cubes[i].NumPixels;
  end;

  // sNZ͑SCube ̕ς̐F
  // B
  if NumPixels = 0 then
  begin
    RAve := 0; GAve := 0; BAve := 0;
    for i := Low to High-1 do
    begin
      RAve := RAve + Cubes[i].Red;
      GAve := GAve + Cubes[i].Green;
      BAve := BAve + Cubes[i].Blue;
    end;
    RAve := RAve div (High - Low);
    GAve := GAve div (High - Low);
    BAve := BAve div (High - Low);
  end
  else
  begin
    RAve := RAve div NumPixels;
    GAve := GAve div NumPixels;
    BAve := BAve div NumPixels;
  end;

  // Depth = MaxDepth ܂A2^MaxDepthQɕĂȂ΁AF̕ς
  // J[e[uɓo^BsNZo^B
  if (Depth = MaxDepth) or (NumPixels = 0) then begin
    Colors[NumColors].rgbRed      := RAve;
    Colors[NumColors].rgbGreen    := GAve;
    Colors[NumColors].rgbBlue     := BAve;
    Colors[NumColors].rgbReserved := 0;
    for i := Low to High -1 do
      Cubes[i].ColorIndex := NumColors;
    // FJ[o^ꂽ
    Inc(NumColors);
    Exit;
  end;

  // Color Cube Q𕪊B
  // ԁA΁A ̂AłЂ낪̑傫FŕBAAr鎞
  // Ԃ1.2{A΂1.4{A1{ĂrB΂Ԃ̕dvȂ߁A
  // ΂ԂŕN₷AǂĩJ[e[uB

  i := Low; j := High;

  if ((RMax-Rmin)*1.2 >= (GMax-GMin)*1.4) and
     ((RMax-RMin)*1.2 >= (BMax-BMin)*1.0) then begin
    // Ԃ Color Cube Q𕪊
    while i < j do begin
      while (i < j) and (Cubes[i].Red <= RAve) do inc(i);
      while (i < j) and (Cubes[j-1].Red > RAve) do dec(j);
      if i <> j then begin
        temp := Cubes[i];
        Cubes[i] := Cubes[j-1];
        Cubes[j-1] := temp;
      end;
    end;
  end else if ((GMax-GMin)*1.4 >= (RMax-Rmin)*1.2) and
              ((GMax-GMin)*1.4 >= (BMax-BMin)*1.0) then begin
    // ΂ Color Cube Q𕪊
    while i < j do begin
      while (i < j) and (Cubes[i].Green <= GAve) do inc(i);
      while (i < j) and (Cubes[j-1].Green >  GAve) do dec(j);
      if i <> j then begin
        temp := Cubes[i];
        Cubes[i] := Cubes[j-1];
        Cubes[j-1] := temp;
      end;
    end;
  end else begin
    //  Color Cube Q𕪊
    while i < j do begin
      while (i < j) and (Cubes[i].Blue <= BAve) do inc(i);
      while (i < j) and (Cubes[j-1].Blue > BAve) do dec(j);
      if i <> j then begin
        temp := Cubes[i];
        Cubes[i] := Cubes[j-1];
        Cubes[j-1] := temp;
      end;
    end;
  end;

  // 邢ɃJbgB̕J[e[u̐擪
  // 邢FW܂B
  CutCubes(i, High, Depth+1, MaxDepth, Cubes, Colors, NumColors);
  CutCubes(Low, i, Depth+1, MaxDepth, Cubes, Colors, NumColors);
end;

// UgăqXgO𕪊
procedure TMedianCut.CutCubesByVariance(Low, High, Depth,
  MaxDepth: Integer; var Cubes: THistogram; var Colors: TRGBQuadArray;
  var NumColors: Integer);
var
  i, j, NumPixels: LongInt;
  RAve, GAve, BAve: Int64;                   // ԁA΁A̕ϒl
  R, G, B: Byte;
  temp: TMedianCutCube;
  RV, GV, BV: Extended;                      // ԁA΁A̕U

begin
   // Low = High ł Cube Q Cube ĂȂB
  if Low = High then Exit;

  // Cube Q̐F̕ςƕUvZ
  RAve := 0; GAve := 0; BAve := 0;
  RV := 0; GV := 0; BV := 0;
  NumPixels := 0;

  for i := Low to High-1 do begin
    Inc(NumPixels, Cubes[i].NumPixels);  // sNZ̑JEg
    R := Cubes[i].Red;
    G := Cubes[i].Green;
    B := Cubes[i].Blue;

    // eFώZ
    RAve := RAve + R * Cubes[i].NumPixels;
    GAve := GAve + G * Cubes[i].NumPixels;
    BAve := BAve + B * Cubes[i].NumPixels;

    // F̂QaώZ
    RV := RV + sqr(Cubes[i].Red * 1.0) * Cubes[i].NumPixels;
    GV := GV + sqr(Cubes[i].Green * 1.0) * Cubes[i].NumPixels;
    BV := BV + sqr(Cubes[i].Blue * 1.0) * Cubes[i].NumPixels;

  end;

  // sNZ͑SCube ̕ς̂
  // B
  if NumPixels = 0 then
  begin
    RAve := 0; GAve := 0; BAve := 0;
    for i := Low to High-1 do
    begin
      RAve := RAve + Cubes[i].Red;
      GAve := GAve + Cubes[i].Green;
      BAve := BAve + Cubes[i].Blue;
    end;
    //eF̕όvZ
    RAve := RAve div (High - Low);
    GAve := GAve div (High - Low);
    BAve := BAve div (High - Low);
  end
  else
  begin
    //eF̕όvZ
    RAve := RAve div NumPixels;
    GAve := GAve div NumPixels;
    BAve := BAve div NumPixels;

    //eF̕UvZ
    RV := RV / NumPixels - sqr(RAve);
    GV := GV / NumPixels - sqr(GAve);
    BV := BV / NumPixels - sqr(BAve);
  end;


  // Depth = MaxDepth ܂A2^MaxDepthQɕĂȂ΁AF̕ς
  // J[e[uɓo^BsNZo^B
  if (Depth = MaxDepth) or (NumPixels = 0) then begin
    Colors[NumColors].rgbRed      := RAve;
    Colors[NumColors].rgbGreen    := GAve;
    Colors[NumColors].rgbBlue     := BAve;
    Colors[NumColors].rgbReserved := 0;
    for i := Low to High -1 do
      Cubes[i].ColorIndex := NumColors;
    // FJ[o^ꂽ
    Inc(NumColors);
    Exit;
  end;

  // Color Cube Q𕪊B
  // ԁA΁A ̂AłȖ傫FŕBAAr鎞
  // Ԃ3{A΂4{A2{ĂrB΂Ԃ̕dvȂ߁A
  // ΂ԂŕN₷AǂĩJ[e[uB

  i := Low; j := High;

  if (RV*3 >= GV*4) and
     (RV*3 >= BV*2) then begin
    // Ԃ Color Cube Q𕪊
    while i < j do begin
      while (i < j) and (Cubes[i].Red <= RAve) do inc(i);
      while (i < j) and (Cubes[j-1].Red > RAve) do dec(j);
      if i <> j then begin
        temp := Cubes[i];
        Cubes[i] := Cubes[j-1];
        Cubes[j-1] := temp;
      end;
    end;
  end else if (GV*4 >= RV*3) and
              (GV*3 >= BV*2) then begin
    // ΂ Color Cube Q𕪊
    while i < j do begin
      while (i < j) and (Cubes[i].Green <= GAve) do inc(i);
      while (i < j) and (Cubes[j-1].Green >  GAve) do dec(j);
      if i <> j then begin
        temp := Cubes[i];
        Cubes[i] := Cubes[j-1];
        Cubes[j-1] := temp;
      end;
    end;
  end else begin
    //  Color Cube Q𕪊
    while i < j do begin
      while (i < j) and (Cubes[i].Blue <= BAve) do inc(i);
      while (i < j) and (Cubes[j-1].Blue > BAve) do dec(j);
      if i <> j then begin
        temp := Cubes[i];
        Cubes[i] := Cubes[j-1];
        Cubes[j-1] := temp;
      end;
    end;
  end;

  // 邢ɃJbgB̕J[e[u̐擪
  // 邢FW܂B
  CutCubesByVariance(i, High, Depth+1, MaxDepth, Cubes, Colors, NumColors);
  CutCubesByVariance(Low, i, Depth+1, MaxDepth, Cubes, Colors, NumColors);
end;

destructor TMedianCut.Destroy;
begin
  FreeMem(FHistogram);
  inherited;
end;

//FJ[e[uCfbNXɕϊ
function TMedianCut.GetColorIndex(Color: TTriple): Integer;
begin
  Result := P3DByteArray(@FColorConvertTable)[Color.R shr 2,
                                              Color.G shr 2,
                                              Color.B shr 3];

end;

// qXgO̕ʂgăpbg
function TMedianCut.MakePalette: HPALETTE;
var
  LogPalette: TMaxLogPalette;
  i: Integer;
begin
  LogPalette.palVersion := $0300;
  LogPalette.palNumEntries := FNumColors;
  for i := 0 to FNumColors-1 do
  begin
    LogPalette.palPalEntry[i].peRed   := FColors[i].rgbRed;
    LogPalette.palPalEntry[i].peGreen := FColors[i].rgbGreen;
    LogPalette.palPalEntry[i].peBlue  := FColors[i].rgbBlue;
    LogPalette.palPalEntry[i].peFlags := 0;
  end;
  Result := CreatePalette(PLogPalette(@LogPalette)^);
end;

// qXgO𕪊
procedure TMedianCut.ReduceColors(MaxDepth: Integer; ShrinkCubes: Boolean);
var
  ri, gi, bi: Integer;  // qXgÕCfbNX
  NumPixels: Integer;   // e Cube ̃sNZ
  i: Integer;
  NumCubes: Integer;    // Cube ̐
begin
  // e Color Cube  RGB l̕ϒl𓾂B
  for ri := 0 to 63 do
    for gi := 0 to 63 do
      for bi := 0 to 31 do begin
        NumPixels := FHistogram[ri, gi, bi].NumPixels;
        if NumPixels <> 0 then begin
          FHistogram[ri, gi, bi].Red :=
            (ri shl 2) + Integer(FHistogram[ri, gi, bi].Red) div NumPixels;
          FHistogram[ri, gi, bi].Green :=
            (gi shl 2) + Integer(FHistogram[ri, gi, bi].Green) div NumPixels;
          FHistogram[ri, gi, bi].Blue :=
            (bi shl 3) + Integer(FHistogram[ri, gi, bi].Blue) div NumPixels;
        end
        else
        begin
          FHistogram[ri, gi, bi].Red :=   (ri shl 2) + 2;
          FHistogram[ri, gi, bi].Green := (gi shl 2) + 2;
          FHistogram[ri, gi, bi].Blue :=  (bi shl 3) + 4;
        end;
      end;

  FNumColors := 0; //oFݒ

  if ShrinkCubes then
  begin
    // sNZ1ȏĂ Color Cube I
    NumCubes := 0;

    for i := 0 to NumTotalCubes-1 do
      if PHistogram(FHistogram)[i].NumPixels <> 0 then begin
        PHistogram(FHistogram)[NumCubes] := PHistogram(FHistogram)[i];
        Inc(NumCubes);
      end;
  end
  else
    NumCubes := NumTotalCubes;;

  // F𒊏o
  CutCubes(0, NumCubes, 0, MaxDepth, PHistogram(FHistogram)^,
           FColors, FNumColors);

  // Fϊe[u
  FillChar(FColorConvertTable, NumTotalCubes, 0);
  for i := 0 to NumCubes-1 do
    FColorConvertTable[PHistogram(FHistogram)[i].Index] :=
      PHistogram(FHistogram)[i].ColorIndex;
end;

// UgăqXgO𕪊
procedure TMedianCut.ReduceColorsByVariance(MaxDepth: Integer; ShrinkCubes: Boolean);
var
  ri, gi, bi: Integer;  // qXgÕCfbNX
  NumPixels: Integer;   // e Cube ̃sNZ
  NumCubes: Integer;    // Cube ̐
  i: Integer;
begin
  // e Color Cube  RGB l̕ϒl𓾂B
  for ri := 0 to 63 do
    for gi := 0 to 63 do
      for bi := 0 to 31 do begin
        NumPixels := FHistogram[ri, gi, bi].NumPixels;
        if NumPixels <> 0 then begin
          FHistogram[ri, gi, bi].Red :=
            (ri shl 2) + Integer(FHistogram[ri, gi, bi].Red) div NumPixels;
          FHistogram[ri, gi, bi].Green :=
            (gi shl 2) + Integer(FHistogram[ri, gi, bi].Green) div NumPixels;
          FHistogram[ri, gi, bi].Blue :=
            (bi shl 3) + Integer(FHistogram[ri, gi, bi].Blue) div NumPixels;
        end
        else
        begin
          FHistogram[ri, gi, bi].Red :=   (ri shl 2) + 2;
          FHistogram[ri, gi, bi].Green := (gi shl 2) + 2;
          FHistogram[ri, gi, bi].Blue :=  (bi shl 3) + 4;
        end;
      end;

  FNumColors := 0; //oFݒ

  if ShrinkCubes then
  begin
    // sNZ1ȏĂ Color Cube I
    NumCubes := 0;

    for i := 0 to NumTotalCubes-1 do
      if PHistogram(FHistogram)[i].NumPixels <> 0 then begin
        PHistogram(FHistogram)[NumCubes] := PHistogram(FHistogram)[i];
        Inc(NumCubes);
      end;
  end
  else
    NumCubes := NumTotalCubes;

  // F𒊏o
  CutCubesByVariance(0, NumCubes, 0, MaxDepth, PHistogram(FHistogram)^,
           FColors, FNumColors);

  // Fϊe[u
  FillChar(FColorConvertTable, NumTotalCubes, 0);
  for i := 0 to NumCubes-1 do
    FColorConvertTable[PHistogram(FHistogram)[i].Index] :=
      PHistogram(FHistogram)[i].ColorIndex;
end;

initialization
  // 
  FillChar(RLookup[0],  26, 0);
  FillChar(RLookup[26], 51, 1);
  FillChar(RLookup[77], 51, 2);
  FillChar(RLookup[128], 51, 3);
  FillChar(RLookup[179], 52, 4);
  FillChar(RLookup[231], 25, 5);

  // 
  FillChar(GLookup[0],  22, 0);
  FillChar(GLookup[22], 42, 1);
  FillChar(GLookup[64], 43, 2);
  FillChar(GLookup[107], 43, 3);
  FillChar(GLookup[150], 43, 4);
  FillChar(GLookup[193], 41, 5);
  FillChar(GLookup[234], 22, 6);

  // 
  FillChar(BLookup[0],  32, 0);
  FillChar(BLookup[32], 64, 1);
  FillChar(BLookup[96], 64, 2);
  FillChar(BLookup[160], 64, 3);
  FillChar(BLookup[224], 32, 4);

  LogPalette.palNumEntries := 210;  // F
  LogPalette.palVersion := $300;

  for RI := 0 to 5 do
    for GI := 0 to 6 do
      for BI := 0 to 4 do
        with LogPalette.palPalEntry[RI*7*5 + GI*5 + BI] do begin
          peRed := RedColors[RI];
          peGreen := GreenColors[GI];
          peBlue := BlueColors[BI];
          peFlags := 0;
        end;

  Palette210 := CreatePalette(PLogPalette(@LogPalette)^);

finalization

  DeleteObject(Palette210);

end.

