unit TurboImg;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, Math, Reduce;

type
  TPictureType = (picNil, picBitmap, picMetafile, picIcon, picUnknown);
  TReduceType = (rdcOctree,      // Octree ŌF
                 rdcMedianCut,   // MedianCut ŌF
                 rdcMedianCutV,  // MedianCut + UŌF
                 rdcMedianCutE,  // MedianCut + 덷gUŌF
                 rdcMedianCutVE, // MedianCut + U + 덷gUŌF
                 rdcStaticE);    // Œpbg + 덷gUŌF

  TTriple = packed record
    B, G, R: Byte;
  end;

  TDoubleTriple = record
    B, G, R: Double;
  end;

  TTripleArray = array[0..40000000] of TTriple;
  PTripleArray = ^TTripleArray;

  TDWordArray = array[0..100000000] of DWORD;
  PDWordArray = ^TDWordArray;

  TNotifyAmendEvent = procedure(Sender: TObject; Kind: String) of object;

  { TTurboImage NX }
  TTurboImage = class(TImage)
  private
    { Private 錾 }
    FKind: String; // ␳̎ނ(\bh)
    FOnAmend: TNotifyAmendEvent;   // OnAmend CxgtB[h
    FOnAmended: TNotifyAmendEvent; // OnAmended CxgtB[h
    function GetBitCount: Integer;
    function GetMScaleFactor: TSize;
    function GetPictureType: TPictureType;
    procedure SetPictureType(const Value: TPictureType);
    function Enlarge_(SrcBitmap: TBitmap; NewWidth, NewHeight: Integer): TBitmap; // Bi-Linear@Ńrbg}bvg
    function Shrink_(SrcBitmap: TBitmap; NewWidth, NewHeight: Integer): TBitmap; // ϕ@Ńrbg}bvk
    function Stretches_(SrcBitmap: TBitmap; NewWidth, NewHeight: Integer): TBitmap; // Bi-Linear & ϕ@Ńrbg}bvgk
  protected
    { Protected 錾 }
    { Cxg\bh錾 }
    procedure Amend; dynamic;
    procedure Amended; dynamic;
  public
    { Public 錾 }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure MinMax(var Min: Integer; var Max: Integer; Rate: Integer; Step: Integer); // Klz̍őlƍŏl߂B
    procedure Turn(Param: Integer); // 摜 90 xPʂŉ]\
    procedure Reverse; // 摜̔]\
    procedure Bright(Param: Integer); // 摜̖邳𒲐
    procedure Contrast(Param: Integer); // RgXg
    procedure Gamma(Param: Extended); // 摜̃K}␳
    procedure GrayScale; // 摜O[XP[(mN)ɕϊ
    procedure BlackAndWhite(Param: Integer; var Border: Integer); // 摜  2 F݂̂̕\ɕϊ
    procedure Sepia; // 摜ZsAɕϊ
    procedure Negative; // 摜̐F𔽓]
    procedure Posterization(Param: Integer); // 摜̊KύX(|X^[[V)
    procedure Edge(Param: Integer); // 摜̃GbW
    procedure Median(Param: Integer); // 摜̃mCY
    procedure Sobel(Param: Integer; Draw: Boolean); // 摜̗֊so邢́A֊s`
    procedure Blur; // 摜̂ڂ
    procedure Mosaic(Param: Integer); // 摜UCNɕϊ
    procedure Framing(ParamWidth: Integer; ParamContrast: Integer;
                      ParamShape: Boolean); // 摜̉zɕϊ
    procedure Light(Param: Integer); // 摜̖邳𒲐
    procedure Linear(Param: Integer; ParamConst:Integer); // 摜ꎟϊ
    procedure Spread(FromMin: Integer; FromMax: Integer; ToMin: Integer; ToMax:Integer); // 摜̖邳̕z͈͕ϊ
    procedure Automatic(Param: Integer); // 摜̖邳␳
    procedure Enlarge(ParamWidth: Integer; ParamHeight: Integer); // 摜 Bi-Linear@Ŋg
    procedure Shrink(ParamWidth: Integer; ParamHeight: Integer); // 摜ϕ@ŏk
    procedure Stretches(ParamWidth: Integer; ParamHeight: Integer); // 摜 Bi-Linear & ϕ@Ŋgk
    procedure Reduce(Param: TReduceType); // 摜 6 ނ̕@ 256 FɌF
    procedure Trimming(ParamR: TRect; ParamG: Boolean); // 摜g~OB
    procedure Histgram(var ToDraw: TGraphic; Size: Integer; Step: Integer; H: Integer);
    property BitCount: Integer read GetBitCount; // 摜̐F(rbg)
    property MScaleFactor: TSize read GetMScaleFactor; // ^t@C̃XP[t@N^(e%)
  published
    { Published 錾 }
    property PictureType: TPictureType read GetPictureType write SetPictureType;
    { Cxg錾 }
    property OnAmend: TNotifyAmendEvent read FOnAmend write FOnAmend;
    property OnAmended: TNotifyAmendEvent read FOnAmended write FOnAmended;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('ToolBox', [TTurboImage]);
end;

{ TTurboImage }

constructor TTurboImage.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FKind := ''; // ␳̎ނ(\bh)
end;

destructor TTurboImage.Destroy;
begin
  inherited Destroy;
end;

procedure TTurboImage.Amend;   // Cxg\bh
begin
  if Assigned(FOnAmend) then
    FOnAmend(Self, FKind);     // CxgnȟĂяo
end;

procedure TTurboImage.Amended; // Cxg\bh
begin
  if Assigned(FOnAmended) then
    FOnAmended(Self, FKind);   // CxgnȟĂяo
end;

{ rbg}bv摜̖邳(Kl)̕z␳܂B}
{ Picture.Graphic is TBitmap łȂꍇсA256 F 8 rbgȉ }
{ J[̏ꍇ́A܂B ␳x Param ́A0 ` 49 ͈̔͂ }
{ w肵ĉBAutomatic() ͓ŁASpread() ĂяoĂ܂B}
procedure TTurboImage.Automatic(Param: Integer);
var
  FromMin, FromMax: Integer;
begin
  FKind := 'Automatic'; // ␳̎ނ FKind ɃZbgB(\bh)
  Amend;                // OnAmend CxgŔ

  if not (Param in [0..49]) then
    Exit;

  MinMax(FromMin, FromMax, Param, 1);
  if FromMin > FromMax then
    Exit; // G[

  Spread(FromMin, FromMax, 0, 255); // 摜̖邳̕z͈͕ϊ

  Amended; // OnAmended CxgŔ
end;

{ rbg}bv摜𔒍 2 F݂̂̕\ɕϊ܂B}
{ GrayScale Ƃ̈Ⴂ́ÅK 2 KAȂ킿ꂩ }
{ ł摜\ȂƂłBPicture.Graphic is TBitmap  }
{ ȂꍇсA256 F 8 rbgȉ̃J[̏ꍇ́A܂B}
{ ̋Ew肷 Param ́A-1 ` 256 ͈̔͂Ŏw肵ĉB}
{ Param = -1 ̏ꍇ́AœKȋElIɌ肵܂B}
{ Border ́A葱Ŏۂɍ̗pꂽElԂׂ̃o[^ }
{ Param = -1 ̏ꍇ́Aۂ̋ElԂAParam <> -1 ̏ꍇ́A}
{ w肳ꂽ Param ̒l̂̂Ԃ܂B}
procedure TTurboImage.BlackAndWhite(Param: Integer; var Border: Integer);
var
  NewBitmap: TBitmap;
  x, y: Integer;
  Min, Max: Integer;
  bd: Integer;
  P: PTripleArray;
  pf: TPixelFormat;
  Col: Integer;
begin
  FKind := 'BlackAndWhite'; // ␳̎ނ FKind ɃZbgB(\bh)
  Amend;                    // OnAmend CxgŔ

  if (Param < -1) or (Param > 256) or (BitCount < 8) then
    Exit; // 8 rbgȉ̃J[̏ꍇ́AȂB

  NewBitmap := (Picture.Graphic as TBitmap);

  pf := NewBitmap.PixelFormat;
  { sȃrbg}bv̉\ꍇ́AI 24bit Color ɂ܂B}
  { ̗lȎ́Aʂ̐F 16bit Color ̏ꍇɂ悭܂B}
  if pf in [pfDevice, pfcustom] then
  begin
    NewBitmap.PixelFormat := pf24bit;
    pf := NewBitmap.PixelFormat;
  end;

  if pf <> pf24bit then
    NewBitmap.PixelFormat := pf24bit; // ꎞI24 rbgJ[ɂB

  if Param = -1 then // Border IɌ
  begin
    MinMax(Min, Max, 40, 1);
    if Min > Max then
    begin
      if pf in [pf8bit, pf32bit] then
        NewBitmap.PixelFormat := pf; // ̏ꍇ́AƂ̃rbg̃J[ɖ߂B
      Exit; // G[
    end;
    Border := (Min + Max) div 2;
  end
  else
    Border := Param;

  bd := Border * 3;
  for y := 0 to NewBitmap.Height - 1 do
  begin
    P := NewBitmap.ScanLine[y];
    for x := 0 to NewBitmap.Width - 1 do
    begin
      if P[x].B + P[x].G + P[x].R < bd then
        Col := 0
      else
        Col := 255;
      P[x].B := Col;
      P[x].G := Col;
      P[x].R := Col;
    end;
  end;

  if pf in [pf8bit, pf32bit] then
    NewBitmap.PixelFormat := pf; // ̏ꍇ́AƂ̃rbg̃J[ɖ߂B

  Invalidate;

  Amended; // OnAmended CxgŔ
end;

{ rbg}bv摜̂ڂsȂ܂B}
{ Picture.Graphic is TBitmap łȂꍇсA256 F 8 rbgȉ }
{ J[̏ꍇ́A܂B}
procedure TTurboImage.Blur;
var
  NewBitmap: TBitmap;
  x, y: Integer;
  xx, yy: Integer;
  w, h: Integer;
  i, n: Integer;
  Blue, Green, Red: Integer;
  pf: TPixelFormat;
  OldBitmap: TBitmap;
  SourceMatrix, DestMatrix: array of PTripleArray;
begin
  FKind := 'Blur'; // ␳̎ނ FKind ɃZbgB(\bh)
  Amend;           // OnAmend CxgŔ

  if BitCount < 8 then // 8 rbgȉ̃J[̏ꍇ́AȂB
    Exit;

  OldBitmap := (Picture.Graphic as TBitmap);

  pf := OldBitmap.PixelFormat;
  { sȃrbg}bv̉\ꍇ́AI 24bit Color ɂ܂B}
  { ̗lȎ́Aʂ̐F 16bit Color ̏ꍇɂ悭܂B}
  if pf in [pfDevice, pfcustom] then
  begin
    OldBitmap.PixelFormat := pf24bit;
    pf := OldBitmap.PixelFormat;
  end;

  if pf <> pf24bit then
    OldBitmap.PixelFormat := pf24bit; // ꎞI24 rbgJ[ɂB

  NewBitmap := TBitmap.Create;
  try
    w := OldBitmap.Width;
    h := OldBitmap.Height;

    NewBitmap.PixelFormat := OldBitmap.PixelFormat;
    NewBitmap.Width := w;
    NewBitmap.Height := h;
    NewBitmap.Palette := CopyPalette(OldBitmap.Palette);

    SetLength(SourceMatrix, h);
    SetLength(DestMatrix, h);
    for i := 0 to h - 1 do
      SourceMatrix[i] := OldBitmap.Scanline[i];

    for i := 0 to h - 1 do
      DestMatrix[i] := NewBitmap.Scanline[i];

    for y := 0 to h - 1 do
    begin
      for x := 0 to w - 1 do
      begin
        n := 0;
        Blue := 0;
        Green := 0;
        Red := 0;
        for yy := y - 1 to y + 1 do
        begin
          for xx := x - 1 to x + 1 do
          begin
            if ((xx >= 0) and (xx <= w - 1)) and ((yy >= 0) and (yy <= h - 1)) then
            begin
              Blue := Blue + SourceMatrix[yy][xx].B;
              Green := Green + SourceMatrix[yy][xx].G;
              Red := Red + SourceMatrix[yy][xx].R;
              Inc(n);
            end;
          end;
        end;
        Blue := Blue div n;
        Green := Green div n;
        Red := Red div n;
        DestMatrix[y][x].B := Blue;
        DestMatrix[y][x].G := Green;
        DestMatrix[y][x].R := Red;
      end;
    end;

    if pf in [pf8bit, pf32bit] then
      NewBitmap.PixelFormat := pf; // ̏ꍇ́AƂ̃rbg̃J[ɖ߂B
    Picture.Graphic := NewBitmap;
  finally
    NewBitmap.Free;
  end;

  Invalidate;

  Amended; // OnAmended CxgŔ
end;

{ rbg}bv摜̖邳𒲐܂B}
{ Picture.Graphic is TBitmap łȂꍇсA256 F 8 rbgȉ }
{ J[̏ꍇ́A܂BƂ̉摜ɑ΂閾邳̔䗦 Param }
{ ́AParam >= 0 ̒lŎw肵ĉB}
procedure TTurboImage.Bright(Param: Integer);
var
  NewBitmap: TBitmap;
  x, y: Integer;
  P: PTripleArray;
  pf: TPixelFormat;
  Col: Integer;
  ColorMap: array[0..255] of Byte;
begin
  FKind := 'Bright'; // ␳̎ނ FKind ɃZbgB(\bh)
  Amend;             // OnAmend CxgŔ

  if (Param < 0) or (Param = 100) or (BitCount < 8) then
    Exit; // 8 rbgȉ̃J[̏ꍇ́AȂB

  NewBitmap := (Picture.Graphic as TBitmap);

  pf := NewBitmap.PixelFormat;
  { sȃrbg}bv̉\ꍇ́AI 24bit Color ɂ܂B}
  { ̗lȎ́Aʂ̐F 16bit Color ̏ꍇɂ悭܂B}
  if pf in [pfDevice, pfcustom] then
  begin
    NewBitmap.PixelFormat := pf24bit;
    pf := NewBitmap.PixelFormat;
  end;

  if pf <> pf24bit then
    NewBitmap.PixelFormat := pf24bit; // ꎞI24 rbgJ[ɂB

  Param := (Param shl 10) div 100;
  for x := 0 to 255 do
  begin
    Col := (x * Param) shr 10;
    if Col > 255 then
      Col := 255;
    ColorMap[x] := Col;
  end;

  for y := 0 to NewBitmap.Height - 1 do
  begin
    P := NewBitmap.ScanLine[y];
    for x := 0 to NewBitmap.Width - 1 do
    begin
      P[x].B := ColorMap[P[x].B];
      P[x].G := ColorMap[P[x].G];
      P[x].R := ColorMap[P[x].R];
    end;
  end;

  if pf in [pf8bit, pf32bit] then
    NewBitmap.PixelFormat := pf; // ̏ꍇ́AƂ̃rbg̃J[ɖ߂B

  Invalidate;

  Amended; // OnAmended CxgŔ
end;

{ rbg}bv摜̃RgXg𒲐܂B}
{ Picture.Graphic is TBitmap łȂꍇсA256 F 8 rbgȉ }
{ J[̏ꍇ́A܂BƂ̉摜ɑ΂RgXg̔䗦 Param }
{ ́AParam >= 0 ̒lŎw肵ĉB}
procedure TTurboImage.Contrast(Param: Integer);
var
  NewBitmap: TBitmap;
  x, y: Integer;
  Border: Integer;
  P: PTripleArray;
  pf: TPixelFormat;
  Col: Integer;
  ColorMap: array[0..255] of Byte;
begin
  FKind := 'Contrast'; // ␳̎ނ FKind ɃZbgB(\bh)
  Amend;               // OnAmend CxgŔ

  if (Param < 0) or (Param = 100) or (BitCount < 8) then
    Exit; // 8 rbgȉ̃J[̏ꍇ́AȂB

  NewBitmap := (Picture.Graphic as TBitmap);

  pf := NewBitmap.PixelFormat;
  { sȃrbg}bv̉\ꍇ́AI 24bit Color ɂ܂B}
  { ̗lȎ́Aʂ̐F 16bit Color ̏ꍇɂ悭܂B}
  if pf in [pfDevice, pfcustom] then
  begin
    NewBitmap.PixelFormat := pf24bit;
    pf := NewBitmap.PixelFormat;
  end;

  if pf <> pf24bit then
    NewBitmap.PixelFormat := pf24bit; // ꎞI24 rbgJ[ɂB

  { 薾邭镔ƂÂ镔𕪂l Border  128 ɌŒ }
  Border := 128;

  for x := 0 to 255 do
  begin
    Col := (x - Border) * Param div 100 + Border;
    if Col < 0 then
      Col := 0
    else if Col > 255 then
      Col := 255;
    ColorMap[x] := Col;
  end;

  for y := 0 to NewBitmap.Height - 1 do
  begin
    P := NewBitmap.ScanLine[y];
    for x := 0 to NewBitmap.Width - 1 do
    begin
      P[x].B := ColorMap[P[x].B];
      P[x].G := ColorMap[P[x].G];
      P[x].R := ColorMap[P[x].R];
    end;
  end;

  if pf in [pf8bit, pf32bit] then
    NewBitmap.PixelFormat := pf; // ̏ꍇ́AƂ̃rbg̃J[ɖ߂B

  Invalidate;

  Amended; // OnAmended CxgŔ
end;

{ rbg}bv摜̃GbW܂B}
{ Picture.Graphic is TBitmap łȂꍇсA256 F 8 rbgȉ }
{ J[̏ꍇ́A܂BGbWx Param ́A}
{ 1 ` 100 ͈̔͂Ŏw肵ĉB}
procedure TTurboImage.Edge(Param: Integer);
var
  NewBitmap: TBitmap;
  x, y, i: Integer;
  xx, yy: Integer;
  w, h: Integer;
  bb, gg, rr: Integer;
  bo, go, ro: Integer;
  pf: TPixelFormat;
  OldBitmap: TBitmap;
  SourceMatrix, DestMatrix: array of PTripleArray;
begin
  FKind := 'Edge'; // ␳̎ނ FKind ɃZbgB(\bh)
  Amend;           // OnAmend CxgŔ

  if (not (Param in [1..100])) or (BitCount < 8) then
    Exit; // 8 rbgȉ̃J[̏ꍇ́AȂB

  OldBitmap := (Picture.Graphic as TBitmap);

  pf := OldBitmap.PixelFormat;
  { sȃrbg}bv̉\ꍇ́AI 24bit Color ɂ܂B}
  { ̗lȎ́Aʂ̐F 16bit Color ̏ꍇɂ悭܂B}
  if pf in [pfDevice, pfcustom] then
  begin
    OldBitmap.PixelFormat := pf24bit;
    pf := OldBitmap.PixelFormat;
  end;

  if pf <> pf24bit then
    OldBitmap.PixelFormat := pf24bit; // ꎞI24 rbgJ[ɂB

  NewBitmap := TBitmap.Create;
  try
    w := OldBitmap.Width;
    h := OldBitmap.Height;

    NewBitmap.PixelFormat := OldBitmap.PixelFormat;
    NewBitmap.Width := w;
    NewBitmap.Height := h;
    NewBitmap.Palette := CopyPalette(OldBitmap.Palette);

    SetLength(SourceMatrix, h);
    SetLength(DestMatrix, h);
    for i := 0 to h - 1 do
      SourceMatrix[i] := OldBitmap.Scanline[i];

    for i := 0 to h - 1 do
      DestMatrix[i] := NewBitmap.Scanline[i];

    for y := 0 to h - 1 do
    begin
      for x := 0 to w - 1 do
      begin
        bo := SourceMatrix[y][x].B; // = (SourceMatrix[y])^[x].B
        go := SourceMatrix[y][x].G; // = (SourceMatrix[y])^[x].G
        ro := SourceMatrix[y][x].R; // = (SourceMatrix[y])^[x].R
        if ((y > 0) and (y < h - 1)) and ((x > 0) and (x < w - 1)) then
        begin
          bb := bo * 5;
          gg := go * 5;
          rr := ro * 5;
          for yy := -1 to 1 do
          begin
            for xx := -1 to 1 do
            begin
              if Abs(xx + yy) = 1 then
              begin
                bb := bb - SourceMatrix[y + yy][x + xx].B;
                gg := gg - SourceMatrix[y + yy][x + xx].G;
                rr := rr - SourceMatrix[y + yy][x + xx].R;
              end;
            end;
          end;
          bb := bo + (bb - bo) * Param div 100;
          if (bb > 255) then
            bb := 255
          else if (bb < 0) then
            bb := 0;
          gg := go + (gg - go) * Param div 100;
          if (gg > 255) then
            gg := 255
          else if (gg < 0) then
            gg := 0;
          rr := ro + (rr - ro) * Param div 100;
          if (rr > 255) then
            rr := 255
          else if (rr < 0) then
            rr := 0;
        end
        else
        begin
          bb := bo;
          gg := go;
          rr := ro;
        end;
        DestMatrix[y][x].B := bb;
        DestMatrix[y][x].G := gg;
        DestMatrix[y][x].R := rr;
      end;
    end;
    if pf in [pf8bit, pf32bit] then
      NewBitmap.PixelFormat := pf; // ̏ꍇ́AƂ̃rbg̃J[ɖ߂B
    Picture.Graphic := NewBitmap;
  finally
    NewBitmap.Free;
  end;

  Invalidate;

  Amended; // OnAmended CxgŔ
end;

{ rbg}bv摜 Bi-Linear@Ŋg債܂B}
{ Picture.Graphic is TBitmap łȂꍇ́A܂B}
{ ParamWidth, ParamHeight ́Ag̐V傫łB}
procedure TTurboImage.Enlarge(ParamWidth: Integer; ParamHeight: Integer);
var
  NewBitmap: TBitmap;
  pf: TPixelFormat;
  OldBitmap: TBitmap;
begin
  FKind := 'Enlarge'; // ␳̎ނ FKind ɃZbgB(\bh)
  Amend;           // OnAmend CxgŔ

  if PictureType <> picBitmap then
    Exit;

  Picture.Bitmap.HandleType := bmDIB;

  OldBitmap := (Picture.Graphic as TBitmap);

  pf := OldBitmap.PixelFormat;
  { sȃrbg}bv̉\ꍇ́AI 24bit Color ɂ܂B}
  { ̗lȎ́Aʂ̐F 16bit Color ̏ꍇɂ悭܂B}
  if pf in [pfDevice, pfcustom] then
  begin
    OldBitmap.PixelFormat := pf24bit;
    pf := OldBitmap.PixelFormat;
  end;

  if (ParamWidth < OldBitmap.Width) or (ParamHeight < OldBitmap.Height) then
    Exit;

  NewBitmap := Enlarge_(OldBitmap, ParamWidth, ParamHeight);
  try
    if not (pf in [pf15bit, pf16bit, pf24bit]) then
      NewBitmap.PixelFormat := pf; // ̏ꍇ́AƂ̃rbg̃J[ɖ߂B
    Picture.Graphic := NewBitmap;
  finally
    NewBitmap.Free;
  end;

  Invalidate;

  Amended; // OnAmended CxgŔ
end;

{ Bi-Linear@Ńrbg}bvg傷֐ }
{ @j@(\tgoNpubVOs) }
{ Delphi Graphic Secrets }
{ Know-how & Libraries }
{ pĂ܂B@jAL܂B}
function TTurboImage.Enlarge_(SrcBitmap: TBitmap; NewWidth, NewHeight: Integer): TBitmap;
var
  NewBitmap, SourceBitmap: TBitmap;
  x, y: Integer; // ϊ x, y Wl
  SourceWidth, SourceHeight: Integer; // ϊ̃rbg}bv̑傫
  XRatio, YRatio, Temp: Double; // g嗦̋t
  a, b, c, d: TTriple; // x, y ϊɓe̋ߖT̃sNZ4_
  p, q, r, s: TDoubleTriple; // ߖT̃sNZ4_狁߂ Bi-Linear ̌W
  SourceScans, NewScans: array of PTripleArray; // ϊAϊ̃XLC|C^̃LbV
  pSourceScan1, pSourceScan2, pNewScan: PTripleArray; // XLCւ̃|C^
  FracX, FracY: Extended; // x, y ϊ֓eƂ̍Wl̏
  IntX, IntY: Integer; // x, y ϊ֓eƂ̍Wl̐
  i: Integer;
begin
  SourceWidth := SrcBitmap.Width; SourceHeight := SrcBitmap.Height;
  assert((SourceWidth > 0) and (SourceHeight > 0));
  XRatio := SourceWidth / NewWidth;
  YRatio := SourceHeight / NewHeight;
  NewBitmap := TBitmap.Create;
  try
    // ϊ rbg}bv
    NewBitmap.PixelFormat := pf24bit;
    NewBitmap.Width := NewWidth; NewBitmap.Height := NewHeight;

    // ϊtJ[ɂ
    SourceBitmap := TBitmap.Create;
    try
      SourceBitmap.Assign(SrcBitmap);
      SourceBitmap.PixelFormat := pf24Bit;

      // XLC|C^̃LbV
      SetLength(SourceScans, SourceHeight);
      SetLength(NewScans, NewHeight);

      for i := 0 to SourceHeight - 1 do
        SourceScans[i] := SourceBitmap.ScanLine[i];

      for i := 0 to NewHeight - 1 do
        NewScans[i] := NewBitmap.Scanline[i];

      for y := 0 to NewHeight - 1 do
      begin
        // ϊXLC|C^𓾂
        pNewScan := NewScans[y];

        // y ϊɓe
        Temp := (y + 0.5) * YRatio - 0.5;
        IntY := floor(Temp);
        FracY := Temp - IntY;

        // IntY YXLC
        // ̎̃XLC߂
        // rbg}bv̒[lB
        if IntY < 0  then
          pSourceScan1 := SourceScans[0]
        else
          pSourceScan1 := SourceScans[IntY];
        if IntY + 1 > SourceHeight - 1 then
          pSourceScan2 := SourceScans[SourceHeight - 1]
        else
          pSourceScan2 := SourceScans[IntY + 1];

        for x := 0 to NewWidth - 1 do
        begin
          // x ϊɓe
          Temp := (x + 0.5) * XRatio - 0.5;
          IntX := Floor(Temp);
          FracX := Temp - IntX;

          // IntX, IntY AߖT4sNZI
          // rbg}bv̒[l
          if IntX < 0 then
          begin
            a := pSourceScan1[0];
            c := pSourceScan2[0];
          end
          else
          begin
            a := pSourceScan1[IntX];
            c := pSourceScan2[IntX];
          end;

          if IntX + 1 > SourceWidth - 1 then
          begin
            b := pSourceScan1[SourceWidth - 1];
            d := pSourceScan2[SourceWidth - 1];
          end
          else
          begin
            b := pSourceScan1[IntX + 1];
            d := pSourceScan2[IntX + 1];
          end;

          // Bi-Linear ̌W߂
          p.R := b.R - a.R;
          s.R := a.R;
          r.R := c.R - a.R;
          q.R := d.R + a.R - b.R - c.R;
          p.G := b.G - a.G;
          s.G := a.G;
          r.G := c.G - a.G;
          q.G := d.G + a.G - b.G - c.G;
          p.B := b.B - a.B;
          s.B := a.B;
          r.B := c.B - a.B;
          q.B := d.B + a.B - b.B - c.B;

          // RGB lvZAϊɑ
          pNewScan[x].R := Round(p.R * FracX + q.R * FracX * FracY + r.R * FracY + s.R);
          pNewScan[x].G := Round(p.G * FracX + q.G * FracX * FracY + r.G * FracY + s.G);
          pNewScan[x].B := Round(p.B * FracX + q.B * FracX * FracY + r.B * FracY + s.B);
        end;
      end;
    finally
      SourceBitmap.Free;
    end;
  except
    NewBitmap.Free;
    Raise;
  end;
  Result := NewBitmap;
end;

{ rbg}bv摜̉zɕϊ܂B}
{ Picture.Graphic is TBitmap łȂꍇсA256 F 8 rbgȉ }
{ J[̏ꍇ́A܂Bzɂ镝 ParamWidth ́A1 ` ŁA}
{ zɂ镔̃RgXgl ParamContrast ́A105 ` 300 ͈̔ }
{ Ŏw肵ĉBĚ̕߂tO ParamShape ́ATrue }
{ ō̌AFalse ŉĚw肵܂B}
procedure TTurboImage.Framing(ParamWidth: Integer; ParamContrast: Integer; ParamShape: Boolean);
var
  NewBitmap: TBitmap;
  x, y: Integer;
  w, h, i: Integer;
  top, tail: Integer;
  Contrast1, Contrast2: Integer;
  Pixel: TTriple;
  Blue, Green, Red: Integer;
  pf: TPixelFormat;
  Matrix: array of PTripleArray;
begin
  FKind := 'Framing'; // ␳̎ނ FKind ɃZbgB(\bh)
  Amend;              // OnAmend CxgŔ

  if (ParamWidth < 1) or (ParamContrast < 105) or (ParamContrast > 300) or
   (BitCount < 8) then // 8 rbgȉ̃J[̏ꍇ́AȂB
    Exit;

  NewBitmap := (Picture.Graphic as TBitmap);

  pf := NewBitmap.PixelFormat;
  { sȃrbg}bv̉\ꍇ́AI 24bit Color ɂ܂B}
  { ̗lȎ́Aʂ̐F 16bit Color ̏ꍇɂ悭܂B}
  if pf in [pfDevice, pfcustom] then
  begin
    NewBitmap.PixelFormat := pf24bit;
    pf := NewBitmap.PixelFormat;
  end;

  if pf <> pf24bit then
    NewBitmap.PixelFormat := pf24bit; // ꎞI24 rbgJ[ɂB

  w := NewBitmap.Width;
  h := NewBitmap.Height;

  Contrast1 := ParamContrast;
  Contrast2 := ((Contrast1 - 100) shr 1) + 100;

  SetLength(Matrix, h);
  for i := 0 to h - 1 do
    Matrix[i] := NewBitmap.Scanline[i];

  { 㕔̕` }
  y := 0;
  top := 0;
  tail := w;
  while ((y < ParamWidth) and (y < h shr 1)) do
  begin
    for x := top to tail -1 do
    begin
      Pixel := Matrix[y][x];
      Blue := Pixel.B; Green := Pixel.G; Red := Pixel.R;
      if ParamShape = True then
      begin
        Blue := Blue * Contrast2 div 100;
        Green := Green * Contrast2 div 100;
        Red := Red * Contrast2 div 100;
      end
      else
      begin
        Blue := Blue * 100 div Contrast2;
        Green := Green * 100 div Contrast2;
        Red := Red * 100 div Contrast2;
      end;
      if Blue > 255 then Blue := 255;
      if Green > 255 then Green := 255;
      if Red > 255 then Red := 255;
      Pixel.B := Blue; Pixel.G := Green; Pixel.R := Red;
      Matrix[y][x] := Pixel;
    end;
    Inc(y);
    Inc(top);
    Dec(tail);
  end;

  { ̕` }
  x := 0;
  top := 1;
  tail := h;
  while ((x < ParamWidth) and (x < w shr 1)) do
  begin
    for y := top to tail -1 do
    begin
      Pixel := Matrix[y][x];
      Blue := Pixel.B; Green := Pixel.G; Red := Pixel.R;
      if ParamShape = True then
      begin
        Blue := Blue * Contrast1 div 100;
        Green := Green * Contrast1 div 100;
        Red := Red * Contrast1 div 100;
      end
      else
      begin
        Blue := Blue * 100 div Contrast1;
        Green := Green * 100 div Contrast1;
        Red := Red * 100 div Contrast1;
      end;
      if Blue > 255 then Blue := 255;
      if Green > 255 then Green := 255;
      if Red > 255 then Red := 255;
      Pixel.B := Blue; Pixel.G := Green; Pixel.R := Red;
      Matrix[y][x] := Pixel;
    end;
    Inc(x);
    Inc(top);
    Dec(tail);
  end;

  { ̕` }
  y := h - 1;
  top := 1;
  tail := w;
  while ((y >= h - ParamWidth) and (y >= h shr 1)) do
  begin
    for x := top to tail -1 do
    begin
      Pixel := Matrix[y][x];
      Blue := Pixel.B; Green := Pixel.G; Red := Pixel.R;
      if ParamShape = True then
      begin
        Blue := Blue * 100 div Contrast2;
        Green := Green * 100 div Contrast2;
        Red := Red * 100 div Contrast2;
      end
      else
      begin
        Blue := Blue * Contrast2 div 100;
        Green := Green * Contrast2 div 100;
        Red := Red * Contrast2 div 100;
      end;
      if Blue > 255 then Blue := 255;
      if Green > 255 then Green := 255;
      if Red > 255 then Red := 255;
      Pixel.B := Blue; Pixel.G := Green; Pixel.R := Red;
      Matrix[y][x] := Pixel;
    end;
    Dec(y);
    Inc(top);
    Dec(tail);
  end;

  { E̕` }
  x := w - 1;
  top := 1;
  tail := h - 1;
  while ((x >= w - ParamWidth) and (x >= w shr 1)) do
  begin
    for y := top to tail -1 do
    begin
      Pixel := Matrix[y][x];
      Blue := Pixel.B; Green := Pixel.G; Red := Pixel.R;
      if ParamShape = True then
      begin
        Blue := Blue * 100 div Contrast1;
        Green := Green * 100 div Contrast1;
        Red := Red * 100 div Contrast1;
      end
      else
      begin
        Blue := Blue * Contrast1 div 100;
        Green := Green * Contrast1 div 100;
        Red := Red * Contrast1 div 100;
      end;
      if Blue > 255 then Blue := 255;
      if Green > 255 then Green := 255;
      if Red > 255 then Red := 255;
      Pixel.B := Blue; Pixel.G := Green; Pixel.R := Red;
      Matrix[y][x] := Pixel;
    end;
    Dec(x);
    Inc(top);
    Dec(tail);
  end;

  if pf in [pf8bit, pf32bit] then
    NewBitmap.PixelFormat := pf; // ̏ꍇ́AƂ̃rbg̃J[ɖ߂B

  Invalidate;

  Amended; // OnAmended CxgŔ
end;

{ rbg}bv摜̃K}␳܂B}
{ Picture.Graphic is TBitmap łȂꍇсA256 F 8 rbgȉ }
{ J[̏ꍇ́A܂BK}l Param ́A0.10 ` 10.00  }
{ ͈͂Ŏw肵ĉB}
procedure TTurboImage.Gamma(Param: Extended);
var
  NewBitmap: TBitmap;
  x, y: Integer;
  P: PTripleArray;
  pf: TPixelFormat;
  ColorMap: array[0..255] of Byte;
begin
  FKind := 'Gamma'; // ␳̎ނ FKind ɃZbgB(\bh)
  Amend;            // OnAmend CxgŔ

  if (Param < 0.10) or (Param > 10.00) or (Param = 1.00) or (BitCount < 8) then
    Exit; // 8 rbgȉ̃J[̏ꍇ́AȂB

  NewBitmap := (Picture.Graphic as TBitmap);

  pf := NewBitmap.PixelFormat;
  { sȃrbg}bv̉\ꍇ́AI 24bit Color ɂ܂B}
  { ̗lȎ́Aʂ̐F 16bit Color ̏ꍇɂ悭܂B}
  if pf in [pfDevice, pfcustom] then
  begin
    NewBitmap.PixelFormat := pf24bit;
    pf := NewBitmap.PixelFormat;
  end;

  if pf <> pf24bit then
    NewBitmap.PixelFormat := pf24bit; // ꎞI24 rbgJ[ɂB

  Param := 1 / Param;
  for x := 0 to 255 do
    ColorMap[x] := Round(255 * Power(x / 255, Param));

  for y := 0 to NewBitmap.Height - 1 do
  begin
    P := NewBitmap.ScanLine[y];
    for x := 0 to NewBitmap.Width - 1 do
    begin
      P[x].B := ColorMap[P[x].B];
      P[x].G := ColorMap[P[x].G];
      P[x].R := ColorMap[P[x].R];
    end;
  end;

  if pf in [pf8bit, pf32bit] then
    NewBitmap.PixelFormat := pf; // ̏ꍇ́AƂ̃rbg̃J[ɖ߂B

  Invalidate;

  Amended; // OnAmended CxgŔ
end;

function TTurboImage.GetBitCount: Integer;
var
  PD: PDIBSection;
begin
  Result := 0;
  if (Picture.Graphic = Nil) or (not (Picture.Graphic is TBitmap)) then
    Exit;
  Picture.Bitmap.HandleType := bmDIB;
  GetMem(PD, SizeOf(TDIBSection) * 100); // Get sufficiently large buffer.
  try
    if GetObject(Picture.Bitmap.Handle, SizeOf(TDIBSection), PD) <> 0 then
      Result := PD^.dsBmih.biBitCount; // GetObject function succeeds.
  finally
    FreeMem(PD);
  end;
end;

function TTurboImage.GetMScaleFactor: TSize;
var
  W, H: Integer;
  Mf: TMetafile;
  MfCanvas: TMetafileCanvas;
begin
  Result.cx := 100; // ʏ́A100 %
  Result.cy := 100; // ʏ́A100 %
  // XN[̃TCY擾B
  W := GetDeviceCaps(GetDC(0), HORZRES);
  H := GetDeviceCaps(GetDC(0), VERTRES);
  // ^t@C̃XP[t@N^擾B
  Mf := TMetafile.Create;
  try
    MfCanvas := TMetafileCanvas.Create(Mf, GetDC(0));
    try
      ;
    finally
      MfCanvas.Free;
    end;
    // ^t@C̃LoX(MfCanvas)j(Free)_ŗ_́A
    // Mf.Width = GetDeviceCaps(GetDC(0), HORZRES); // = Screen.Width
    // Mf.Height = GetDeviceCaps(GetDC(0), VERTRES); // Screen.Height
    // ƂȂȂƂ̂łÂƂ̃XN[̉𑜓x
    // (DPI l)ɂẮAȂȂꍇ܂B
    // MScaleFactor vpeB́AXN[foCXReLXg
    // w肵ă^t@C̃LoX쐬ꍇAۂ̃^t@C
    // ̑傫_̑傫̉ % ɂȂ邩̂łB
    // ʏ́A100 % łB
    // `̑傫XN[foCXɂ悤ɂ܂B(Inch <> 0)
    Mf.Inch := 1;
    Result.cx := Mf.Width * 100 div W;
    Result.cy := Mf.Height * 100 div H;
  finally
    Mf.Free;
  end;
end;

function TTurboImage.GetPictureType: TPictureType;
begin
  if Picture.Graphic = Nil then
    Result := picNil
  else if Picture.Graphic is TBitmap then
    Result := picBitmap
  else if Picture.Graphic is TMetafile then
    Result := picMetafile
  else if Picture.Graphic is TIcon then
    Result := picIcon
  else
    Result := picUnknown;
end;

{ rbg}bv摜O[XP[(mN)ɕϊ܂B}
{ Picture.Graphic is TBitmap łȂꍇсA256 F 8 rbgȉ }
{ J[̏ꍇ́A܂B}
procedure TTurboImage.GrayScale;
var
  NewBitmap: TBitmap;
  x, y: Integer;
  P: PTripleArray;
  pf: TPixelFormat;
  Col: Integer;
  BMap: array[0..255] of Byte;
  GMap: array[0..255] of Byte;
  RMap: array[0..255] of Byte;
begin
  FKind := 'GrayScale'; // ␳̎ނ FKind ɃZbgB(\bh)
  Amend;                // OnAmend CxgŔ

  if BitCount < 8 then // 8 rbgȉ̃J[̏ꍇ́AȂB
    Exit;

  NewBitmap := (Picture.Graphic as TBitmap);

  pf := NewBitmap.PixelFormat;
  { sȃrbg}bv̉\ꍇ́AI 24bit Color ɂ܂B}
  { ̗lȎ́Aʂ̐F 16bit Color ̏ꍇɂ悭܂B}
  if pf in [pfDevice, pfcustom] then
  begin
    NewBitmap.PixelFormat := pf24bit;
    pf := NewBitmap.PixelFormat;
  end;

  if pf <> pf24bit then
    NewBitmap.PixelFormat := pf24bit; // ꎞI24 rbgJ[ɂB

  for x := 0 to 255 do
  begin
    BMap[x] := (x * 117) shr 10;
    GMap[x] := (x * 601) shr 10;
    RMap[x] := (x * 306) shr 10;
  end;

  for y := 0 to NewBitmap.Height - 1 do
  begin
    P := NewBitmap.ScanLine[y];
    for x := 0 to NewBitmap.Width - 1 do
    begin
      Col := BMap[P[x].B] + GMap[P[x].G] + RMap[P[x].R];
      P[x].B := Col;
      P[x].G := Col;
      P[x].R := Col;
    end;
  end;

  if pf in [pf8bit, pf32bit] then
    NewBitmap.PixelFormat := pf; // ̏ꍇ́AƂ̃rbg̃J[ɖ߂B

  Invalidate;

  Amended; // OnAmended CxgŔ
end;

{ ݕ\Ă摜̃qXgOw肳ꂽ ToDraw :TGraphic }
{ ɕ`悷葱łB ݕ\̉摜ǂ̗lȎނłĂ }
{ qXgO`悵܂A\ ToDraw :TGraphic ́A}
{ rbg}bv^t@CłȂ΂Ȃ܂B\TCY Size ́A}
{ 1 ` 5 ͈̔͂Ŏw肵ĉB܂qXgO`悷ۂ̊K }
{ ̃Xebvl肷 Step ́A0 ` 3 ͈̔͂Ŏw肵ĉB}
{ ۂ̃XebvĺA2  Step ƂȂ܂B Step ̒lق }
{ 萳młȂ߂炩ȃqXgOOt܂A\ɎԂ }
{ lɂȂ܂B܂ H ̓Ot̂Ď̍őlw肷lŁA}
{ ݕ\Ă摜̑SsNZɑ΂銄(% l)킵܂B}
{ H ́A0 ` 100 ͈̔͂Ŏw肵ĉB H = 0 ̏ꍇ́A }
{ 葱ōœK H ̒lvZĂ̒lɐݒ肵܂BH > 0 ̏ꍇ́A}
{ ̒lɌŒ肳܂B̏ꍇA10 ` 50 ʂ̒lǂƎv܂B}
procedure TTurboImage.Histgram(var ToDraw: TGraphic; Size: Integer; Step: Integer; H: Integer);
var
  Bmp: TBitmap;              // qXgO`悷rbg}bv
  Mf: TMetafile;             // qXgO`悷郁^t@C
  MfCanvas: TMetafileCanvas; // qXgO`悷ׂ̃^t@CLoX
  B, G, R: array of Integer; // eKlWvׂ̔z
  Count: Integer;            // qXgO`悷ۂ̐܂̐
  mu, max: Integer;
  x, y: Integer;
  P: PTripleArray;
  MS: TSize;

  procedure DrawHistgram(Canvas: TCanvas);
  var
    i: Integer;
    xx, yy: Integer;
    d, sp: Integer;
  begin
    Canvas.Brush.Color := clBtnFace;
    Canvas.FillRect(Rect(0, 0, 286 * Size, 175 * Size));

    if PictureType = picNil then
      Exit;

    d := 8 * 32 div Count;
    sp := 15 + (d shr 1);

    Canvas.Pen.Color := TColor($00FF0000);
    xx := sp;
    for i := 0 to Count - 1 do
    begin
      yy := 175 - 16 - (B[i] * 150 div H);
      if i = 0 then
        Canvas.MoveTo(xx * Size, yy * Size)
      else
        Canvas.LineTo(xx * Size, yy * Size);
      xx := xx + d;
    end;

    Canvas.Pen.Color := TColor($0000FF00);
    xx := sp;
    for i := 0 to Count - 1 do
    begin
      yy := 175 - 16 - (G[i] * 150 div H);
      if i = 0 then
        Canvas.MoveTo(xx * Size, yy * Size)
      else
        Canvas.LineTo(xx * Size, yy * Size);
      xx := xx + d;
    end;

    Canvas.Pen.Color := TColor($000000FF);
    xx := sp;
    for i := 0 to Count - 1 do
    begin
      yy := 175 - 16 - (R[i] * 150 div H);
      if i = 0 then
        Canvas.MoveTo(xx * Size, yy * Size)
      else
        Canvas.LineTo(xx * Size, yy * Size);
      xx := xx + d;
    end;
  end;

  procedure DrawFrame(Canvas: TCanvas);
  var
    m, n: Integer;
    len: Integer;
    S: String;
  begin
    Canvas.Pen.Color := clBlack;
    Canvas.Font.Size := 8 * Size;

    Canvas.MoveTo(15 * Size, 10);
    Canvas.LineTo(15 * Size, (175 - 16) * Size);
    Canvas.LineTo((286 - 15) * Size, (175 - 16) * Size);
    Canvas.LineTo((286 - 15) * Size, 10);

    Canvas.MoveTo(11 * Size, (175 - 16 - 74) * Size);
    Canvas.LineTo(14 * Size, (175 - 16 - 74) * Size);
    Canvas.MoveTo((286 - 14) * Size, (175 - 16 - 74) * Size);
    Canvas.LineTo((286 - 11) * Size, (175 - 16 - 74) * Size);

    if PictureType <> picNil then
      Canvas.TextOut((286 - 13) * Size, (175 - 16 - 72) * Size, IntToStr(H shr 1));
    if ((H shr 1) < 10) or (PictureType = picNil) then // 1 
      len := 0
    else
      len := (Canvas.TextWidth(IntToStr(H shr 1)) - Canvas.TextWidth('%')) shr 1;
    Canvas.TextOut((286 - 13) * Size + len, (175 - 16 - 62) * Size, '%');

    for m := 0 to 16 do
    begin
      n := m * 2 * 8 + 15;
      if (m mod 2) = 0 then
        len := 3
      else
        len := 1;
      Canvas.MoveTo(n * Size, (175 - 15) * Size);
      Canvas.LineTo(n * Size, (175 - 15 + len) * Size);
      if (m mod 4) = 0 then
      begin
        if m = 16 then
          S := '255'
        else
          S := IntToStr(m * 16);
        len := Canvas.TextWidth(S) div 2;
        Canvas.TextOut(n * Size - len, (175 - 13) * Size, S);
      end;
    end;
  end;

begin
  if (not ((ToDraw is TBitmap) or (ToDraw is TMetafile)))
   or (not (Size in [1..5])) or (not (Step in [0..3])) or (not (H in [0..100])) then
    Exit;

  { z̏ }
  Count := 256 shr Step; // 256, 128, 64, 32 ꂩ̒lɂȂ܂B
  SetLength(B, Count); SetLength(G, Count); SetLength(R, Count);
  for x := 0 to Count - 1 do
  begin
    B[x] := 0; G[x] := 0; R[x] := 0;
  end;

  { Picture.Graphic rbg}bvɕϊāAezɃqXgO }
  { `ׂ̃f[^擾܂B }
  if PictureType <> picNil then
  begin
    Bmp := TBitmap.Create;
    try
      if PictureType = picBitmap then
        Bmp.Assign(Picture.Graphic)
      else
      begin
        Bmp.Width := Picture.Width;
        Bmp.Height := Picture.Height;
        Bmp.Canvas.Draw(0, 0, Picture.Graphic);
      end;
      Bmp.PixelFormat := pf24bit; // 24 rbgJ[ɂB
      for y := 0 to Bmp.Height - 1 do
      begin
        P := Bmp.ScanLine[y];
        for x := 0 to Bmp.Width - 1 do
        begin
          Inc(B[P[x].B shr Step]);
          Inc(G[P[x].G shr Step]);
          Inc(R[P[x].R shr Step]);
        end;
      end;
    finally
      Bmp.Free;
    end;
  end;

  { ez̒l摜̑SsNZɑ΂銄(%l)ɕϊȂ }
  { ̂Ȃ̍ől max Ɏ擾A H ̒l肵܂B }
  if PictureType <> picNil then
  begin
    mu := Picture.Width * Picture.Height; // 摜̑SsNZ
    max := 0;
    for x := 0 to Count - 1 do
    begin
      B[x] := B[x] * 100 div mu; if B[x] > max then max := B[x];
      G[x] := G[x] * 100 div mu; if G[x] > max then max := G[x];
      R[x] := R[x] * 100 div mu; if R[x] > max then max := R[x];
    end;
    if H = 0 then // ̏ꍇAœK H ̒l 20 ̔{ɂȂl
    begin         // ɌvZĎݒ肵܂B
      H := max div 20;
      if (max mod 20) <> 0 then
        Inc(H);
      H := H * 20;
    end
    else   // H > 0 ̏ꍇ́A^ꂽlł΋ɂ
    begin  // ݂̍ől max ̒lɊ֌ŴȂlƂĂ̂܂܎g܂B
      if (H mod 2) <> 0 then
        Inc(H);
    end;
  end;

  { ` ToDraw ̎ނɂrbg}bv`^t@C` }
  { qXgO`܂B}
  if ToDraw is TBitmap then
  begin
    Bmp := (ToDraw as TBitmap);
    Bmp.Width := 286 * Size;
    Bmp.Height := 175 * Size;
    DrawHistgram(Bmp.Canvas);
    DrawFrame(Bmp.Canvas);
  end
  else
  begin
    MS := MScaleFactor; // ^t@C̃XP[t@N^
    Mf := (ToDraw as TMetafile);
    Mf.Width := 286 * Size;
    Mf.Height := 175 * Size;
    MfCanvas := TMetafileCanvas.Create(Mf, GetDC(0));
    try
      DrawHistgram(MfCanvas);
      DrawFrame(MfCanvas);
    finally
      MfCanvas.Free;
    end;
    { `̑傫XN[foCXɂ悤ɂB(Inch <> 0) }
    Mf.Inch := 1;
    { TCY␳B}
    Mf.Width := Mf.Width * 100 div MS.cx;
    Mf.Height := Mf.Height * 100 div MS.cy;
  end;
end;

{ rbg}bv摜̖邳𒲐܂B}
{ Picture.Graphic is TBitmap łȂꍇсA256 F 8 rbgȉ }
{ J[̏ꍇ́A܂BƂ̉摜ɑ΂閾邳̑l Param }
{ ́A-255 ` 255 ͈̔͂Ŏw肵ĉBBright() Ƃ̈Ⴂ́AParam }
{ ̒lZł͂ȂZ邱Ƃɂ薾邳𒲐Ƃ_ɂ܂B}
{ ɂ芮Sɍł邭鎖\łBprɂ Bright() }
{  Light() gĉB}
procedure TTurboImage.Light(Param: Integer);
var
  NewBitmap: TBitmap;
  x, y: Integer;
  P: PTripleArray;
  pf: TPixelFormat;
  Col: Integer;
  ColorMap: array[0..255] of Byte;
begin
  FKind := 'Light'; // ␳̎ނ FKind ɃZbgB(\bh)
  Amend;            // OnAmend CxgŔ

  if (Param < -255) or (Param > 255) or (Param = 0) or (BitCount < 8) then
    Exit; // 8 rbgȉ̃J[̏ꍇ́AȂB

  NewBitmap := (Picture.Graphic as TBitmap);

  pf := NewBitmap.PixelFormat;
  { sȃrbg}bv̉\ꍇ́AI 24bit Color ɂ܂B}
  { ̗lȎ́Aʂ̐F 16bit Color ̏ꍇɂ悭܂B}
  if pf in [pfDevice, pfcustom] then
  begin
    NewBitmap.PixelFormat := pf24bit;
    pf := NewBitmap.PixelFormat;
  end;

  if pf <> pf24bit then
    NewBitmap.PixelFormat := pf24bit; // ꎞI24 rbgJ[ɂB

  for x := 0 to 255 do
  begin
    Col := x + Param; // ZB
    if Col < 0 then
      Col := 0
    else if Col > 255 then
      Col := 255;
    ColorMap[x] := Col;
  end;

  for y := 0 to NewBitmap.Height - 1 do
  begin
    P := NewBitmap.ScanLine[y];
    for x := 0 to NewBitmap.Width - 1 do
    begin
      P[x].B := ColorMap[P[x].B];
      P[x].G := ColorMap[P[x].G];
      P[x].R := ColorMap[P[x].R];
    end;
  end;

  if pf in [pf8bit, pf32bit] then
    NewBitmap.PixelFormat := pf; // ̏ꍇ́AƂ̃rbg̃J[ɖ߂B

  Invalidate;

  Amended; // OnAmended CxgŔ
end;

{ rbg}bv摜̖邳(Kl) y = ax + b ŕ\킳钼̎ }
{ gĕϊsȂ܂Bx ͕ϊO̊KlAy ͕ϊ̊KlŁA}
{  Param = a * 100, ParamConst = b ɑ܂Be̎l }
{ ͈͎w͂܂BPicture.Graphic is TBitmap łȂꍇ }
{ 256 F 8 rbgȉ̃J[̏ꍇ́A܂B}
{ ̃\bh́ALinear() gēo܂B}
{ Bright(Param) ===> Linear(Param, 0) ɑ }
{ Light(Param) ===> Linear(100, Param) ɑ }
{ Negative ===> Linear(-100, 255) ɑ }
{ ܂ASpread() ͓ Linear() ĂяoɂĎĂ܂B}
procedure TTurboImage.Linear(Param: Integer; ParamConst:Integer);
var
  NewBitmap: TBitmap;
  x, y: Integer;
  P: PTripleArray;
  pf: TPixelFormat;
  Col: Integer;
  ColorMap: array[0..255] of Byte;
begin
  FKind := 'Linear'; // ␳̎ނ FKind ɃZbgB(\bh)
  Amend;             // OnAmend CxgŔ

  if ((Param = 100) and (ParamConst = 0)) or (BitCount < 8) then
    Exit; // 8 rbgȉ̃J[̏ꍇ́AȂB

  NewBitmap := (Picture.Graphic as TBitmap);

  pf := NewBitmap.PixelFormat;
  { sȃrbg}bv̉\ꍇ́AI 24bit Color ɂ܂B}
  { ̗lȎ́Aʂ̐F 16bit Color ̏ꍇɂ悭܂B}
  if pf in [pfDevice, pfcustom] then
  begin
    NewBitmap.PixelFormat := pf24bit;
    pf := NewBitmap.PixelFormat;
  end;

  if pf <> pf24bit then
    NewBitmap.PixelFormat := pf24bit; // ꎞI24 rbgJ[ɂB

  Param := (Param shl 10) div 100;
  for x := 0 to 255 do
  begin
    Col := ((x * Param) shr 10) + ParamConst;
    if Col < 0 then
      Col := 0
    else if Col > 255 then
      Col := 255;
    ColorMap[x] := Col;
  end;

  for y := 0 to NewBitmap.Height - 1 do
  begin
    P := NewBitmap.ScanLine[y];
    for x := 0 to NewBitmap.Width - 1 do
    begin
      P[x].B := ColorMap[P[x].B];
      P[x].G := ColorMap[P[x].G];
      P[x].R := ColorMap[P[x].R];
    end;
  end;

  if pf in [pf8bit, pf32bit] then
    NewBitmap.PixelFormat := pf; // ̏ꍇ́AƂ̃rbg̃J[ɖ߂B

  Invalidate;

  Amended; // OnAmended CxgŔ
end;

{ fBAtB^ɂāArbg}bv摜̃mCY܂B}
{ Picture.Graphic is TBitmap łȂꍇсA256 F 8 rbgȉ }
{ J[̏ꍇ́A܂BmCY̓x Param ́A0 ` 100 }
{ ͈̔͂Ŏw肵ĉB}
procedure TTurboImage.Median(Param: Integer);
var
  NewBitmap: TBitmap;
  x, y: Integer;
  i, j, n: Integer;
  xx, yy: Integer;
  w, h: Integer;
  Sum: Integer;
  Sums: array[0..8] of Integer;
  Pixel: TTriple;
  Pixels: array[0..8] of TTriple;
  temp: Integer;
  tempr: TTriple;
  pf: TPixelFormat;
  OldBitmap: TBitmap;
  SourceMatrix, DestMatrix: array of PTripleArray;
begin
  FKind := 'Median'; // ␳̎ނ FKind ɃZbgB(\bh)
  Amend;             // OnAmend CxgŔ

  if (not (Param in [0..100])) or (BitCount < 8) then
    Exit; // 8 rbgȉ̃J[̏ꍇ́AȂB

  OldBitmap := (Picture.Graphic as TBitmap);

  pf := OldBitmap.PixelFormat;
  { sȃrbg}bv̉\ꍇ́AI 24bit Color ɂ܂B}
  { ̗lȎ́Aʂ̐F 16bit Color ̏ꍇɂ悭܂B}
  if pf in [pfDevice, pfcustom] then
  begin
    OldBitmap.PixelFormat := pf24bit;
    pf := OldBitmap.PixelFormat;
  end;

  if pf <> pf24bit then
    OldBitmap.PixelFormat := pf24bit; // ꎞI24 rbgJ[ɂB

  Param := 100 - Param;
  Param := Param * 255 div 100;

  NewBitmap := TBitmap.Create;
  try
    w := OldBitmap.Width;
    h := OldBitmap.Height;

    NewBitmap.PixelFormat := OldBitmap.PixelFormat;
    NewBitmap.Width := w;
    NewBitmap.Height := h;
    NewBitmap.Palette := CopyPalette(OldBitmap.Palette);

    SetLength(SourceMatrix, h);
    SetLength(DestMatrix, h);
    for i := 0 to h - 1 do
      SourceMatrix[i] := OldBitmap.Scanline[i];

    for i := 0 to h - 1 do
      DestMatrix[i] := NewBitmap.Scanline[i];

    for y := 0 to h - 1 do
    begin
      for x := 0 to w - 1 do
      begin
        Pixel := SourceMatrix[y][x];
        Sum := Integer(Pixel.B) + Integer(Pixel.G) + Integer(Pixel.R);
        n := 0;
        for yy := y - 1 to y + 1 do
        begin
          for xx := x - 1 to x + 1 do
          begin
            if ((yy >= 0) and (yy <= h - 1)) and ((xx >= 0) and (xx <= w - 1)) then
            begin
              Pixels[n] := SourceMatrix[yy][xx];
              Sums[n] := Integer(Pixels[n].B) + Integer(Pixels[n].G) + Integer(Pixels[n].R);
              Inc(n);
            end;
          end;
        end;
        for j := 0 to n div 2 do
        begin
          for i := j + 1 to n - 1 do
          begin
            if Sums[i] < Sums[j] then
            begin
              temp := Sums[j]; Sums[j] := Sums[i]; Sums[i] := temp;
              tempr := Pixels[j]; Pixels[j] := Pixels[i]; Pixels[i] := tempr;
            end;
          end;
        end;
        j := n div 2;
        if Abs(Sum - Sums[j]) >= Param then
          Pixel := Pixels[j];
        DestMatrix[y][x] := Pixel;
      end;
    end;
    if pf in [pf8bit, pf32bit] then
      NewBitmap.PixelFormat := pf; // ̏ꍇ́AƂ̃rbg̃J[ɖ߂B
    Picture.Graphic := NewBitmap;
  finally
    NewBitmap.Free;
  end;

  Invalidate;

  Amended; // OnAmended CxgŔ
end;

{ 摜̖邳(Kl)̕z̒ŁA Rate % ߂n_ Min  }
{ ォ Rate % ߂n_ Max ߂葱łBE΁E }
{ RF̂ȂŁAMin ͍łl Max ͍ł傫l̗p܂B}
{ Picture.Graphic is TBitmap łȂꍇсA256 F 8 rbgȉ }
{ J[̏ꍇ́AG[ƂȂAMin = 255, Max = 0 ƂlԂ܂B}
{ PixelFormat ̒ls̏ꍇG[ƂȂ܂B}
{ Rate ́A0 ` 49 ͈̔͂Ŏw肵ĉB}
{ Step ́A傫ȃrbg}bvlȏꍇׂ̈ɐ݂ŁA}
{ Step sNZƂɌ܂BStep ́A1 ` 8 ͈̔͂Ŏw肵ĉB}
{ Step = 1 ̏ꍇ͑SẴsNZ܂B}
procedure TTurboImage.MinMax(var Min: Integer; var Max: Integer; Rate: Integer; Step: Integer);
var
  NewBitmap: TBitmap;
  B, G, R: array of Integer; // eKlWvׂ̔z
  Total: Integer; // WvsNZ
  SumB, SumG, SumR: Integer;
  P: PTripleArray;
  x, y: Integer;
  w, h: Integer;
  pf: TPixelFormat;
begin
  Min := 255;
  Max := 0;
  if (not (Rate in [0..49])) or (not (Step in [1..8])) or (BitCount < 8) then
    Exit; // 8 rbgȉ̃J[̏ꍇ́AG[B

  NewBitmap := (Picture.Graphic as TBitmap);

  pf := NewBitmap.PixelFormat;
  { sȃrbg}bv̉\ꍇ́AI 24bit Color ɂ܂B}
  { ̗lȎ́Aʂ̐F 16bit Color ̏ꍇɂ悭܂B}
  if pf in [pfDevice, pfcustom] then
  begin
    NewBitmap.PixelFormat := pf24bit;
    pf := NewBitmap.PixelFormat;
  end;

  if pf <> pf24bit then
    NewBitmap.PixelFormat := pf24bit; // ꎞI24 rbgJ[ɂB

  { z̏ }
  SetLength(B, 256); SetLength(G, 256); SetLength(R, 256);
  for x := 0 to 255 do
  begin
    B[x] := 0; G[x] := 0; R[x] := 0;
  end;

  { eKlWv }
  h := NewBitmap.Height; w := NewBitmap.Width;
  Total := 0;
  y := 0;
  while y < h do
  begin
    P := NewBitmap.ScanLine[y];
    x := 0;
    while x < w do
    begin
      Inc(B[P[x].B]);
      Inc(G[P[x].G]);
      Inc(R[P[x].R]);
      x := x + Step;
      Inc(Total);
    end;
    y := y + Step;
  end;

  SumB := 0; SumG := 0; SumR := 0;
  x := 0;
  while x <= 255 do
  begin
    SumB := SumB + B[x];
    if (SumB * 100 div Total) > Rate then
      Break;
    SumG := SumG + G[x];
    if (SumG * 100 div Total) > Rate then
      Break;
    SumR := SumR + R[x];
    if (SumR * 100 div Total) > Rate then
      Break;
    Inc(x);
  end;
  Min := x - 1;
  if Min < 0 then
    Min := 0;

  SumB := 0; SumG := 0; SumR := 0;
  x := 255;
  while x >= 0 do
  begin
    SumB := SumB + B[x];
    if (SumB * 100 div Total) > Rate then
      Break;
    SumG := SumG + G[x];
    if (SumG * 100 div Total) > Rate then
      Break;
    SumR := SumR + R[x];
    if (SumR * 100 div Total) > Rate then
      Break;
    Dec(x);
  end;
  Max := x + 1;
  if Max > 255 then
    Max := 255;

  if pf in [pf8bit, pf32bit] then
    NewBitmap.PixelFormat := pf; // ̏ꍇ́AƂ̃rbg̃J[ɖ߂B
end;

{ rbg}bv摜UCNɕϊ܂B}
{ Picture.Graphic is TBitmap łȂꍇсA256 F 8 rbgȉ }
{ J[̏ꍇ́A܂BX̃UCN̑傫 Param ́A}
{ 2 ` 50 ͈̔͂Ŏw肵ĉB}
procedure TTurboImage.Mosaic(Param: Integer);
var
  NewBitmap: TBitmap;
  x, y: Integer;
  xx, yy: Integer;
  w, h, i: Integer;
  Pixel: TTriple;
  pf: TPixelFormat;
  Matrix: array of PTripleArray;
begin
  FKind := 'Mosaic'; // ␳̎ނ FKind ɃZbgB(\bh)
  Amend;             // OnAmend CxgŔ

  if (not (Param in [2..50])) or (BitCount < 8) then
    Exit; // 8 rbgȉ̃J[̏ꍇ́AȂB

  NewBitmap := (Picture.Graphic as TBitmap);

  pf := NewBitmap.PixelFormat;
  { sȃrbg}bv̉\ꍇ́AI 24bit Color ɂ܂B}
  { ̗lȎ́Aʂ̐F 16bit Color ̏ꍇɂ悭܂B}
  if pf in [pfDevice, pfcustom] then
  begin
    NewBitmap.PixelFormat := pf24bit;
    pf := NewBitmap.PixelFormat;
  end;

  if pf <> pf24bit then
    NewBitmap.PixelFormat := pf24bit; // ꎞI24 rbgJ[ɂB

  w := NewBitmap.Width;
  h := NewBitmap.Height;

  SetLength(Matrix, h);
  for i := 0 to h - 1 do
    Matrix[i] := NewBitmap.Scanline[i];

  i := Param shr 1;
  y := 0;
  while y < h do
  begin
    x := 0;
    while x < w do
    begin
      if (y + i < h) and (x + i < w) then
        Pixel := Matrix[y + i][x + i]
      else
        Pixel := Matrix[y][x];
      for yy := y to y + Param - 1 do
      begin
        if yy >= h then
          Break;
        for xx := x to x + Param - 1 do
        begin
          if xx >= w then
            Break;
          Matrix[yy][xx] := Pixel;
        end;
      end;
      x := x + Param;
    end;
    y := y + Param;
  end;

  if pf in [pf8bit, pf32bit] then
    NewBitmap.PixelFormat := pf; // ̏ꍇ́AƂ̃rbg̃J[ɖ߂B

  Invalidate;

  Amended; // OnAmended CxgŔ
end;

{ rbg}bv摜̐F𔽓]܂B(lKeBu]) }
{ Picture.Graphic is TBitmap łȂꍇсA256 F 8 rbgȉ }
{ J[̏ꍇ́A܂B}
procedure TTurboImage.Negative;
var
  NewBitmap: TBitmap;
  x, y: Integer;
  P: PTripleArray;
  pf: TPixelFormat;
  ColorMap: array[0..255] of Byte;
begin
  FKind := 'Negative'; // ␳̎ނ FKind ɃZbgB(\bh)
  Amend;               // OnAmend CxgŔ

  if BitCount < 8 then // 8 rbgȉ̃J[̏ꍇ́AȂB
    Exit;

  NewBitmap := (Picture.Graphic as TBitmap);

  pf := NewBitmap.PixelFormat;
  { sȃrbg}bv̉\ꍇ́AI 24bit Color ɂ܂B}
  { ̗lȎ́Aʂ̐F 16bit Color ̏ꍇɂ悭܂B}
  if pf in [pfDevice, pfcustom] then
  begin
    NewBitmap.PixelFormat := pf24bit;
    pf := NewBitmap.PixelFormat;
  end;

  if pf <> pf24bit then
    NewBitmap.PixelFormat := pf24bit; // ꎞI24 rbgJ[ɂB

  for x := 0 to 255 do
    ColorMap[x] := not x;

  for y := 0 to NewBitmap.Height - 1 do
  begin
    P := NewBitmap.ScanLine[y];
    for x := 0 to NewBitmap.Width - 1 do
    begin
      P[x].B := ColorMap[P[x].B];
      P[x].G := ColorMap[P[x].G];
      P[x].R := ColorMap[P[x].R];
    end;
  end;

  if pf in [pf8bit, pf32bit] then
    NewBitmap.PixelFormat := pf; // ̏ꍇ́AƂ̃rbg̃J[ɖ߂B

  Invalidate;

  Amended; // OnAmended CxgŔ
end;

{ rbg}bv摜Ƀ|X^[[V(KύX){܂B }
{ Picture.Graphic is TBitmap łȂꍇсA256 F 8 rbgȉ }
{ J[̏ꍇ́A܂BK Param ́A2 ` 128 ͈̔͂Ŏw }
{ ĉB|X^[[VƂ́A摜̊KύXׂ̏łB}
{ ʏ24 rbgJ[摜́AE΁E eX 256 Kŕ\Ă܂A}
{ ̊KύX邱ƂŗlXȌʂoƂoA܂̏ }
{ ̑OƂĎg邱Ƃ܂B}
procedure TTurboImage.Posterization(Param: Integer);
var
  NewBitmap: TBitmap;
  x, y: Integer;
  term, range: Integer;
  P: PTripleArray;
  pf: TPixelFormat;
  ColorMap: array[0..255] of Byte;
begin
  FKind := 'Posterization'; // ␳̎ނ FKind ɃZbgB(\bh)
  Amend;                    // OnAmend CxgŔ

  if (not (Param in [2..128])) or (BitCount < 8) then
    Exit; // 8 rbgȉ̃J[̏ꍇ́AȂB

  NewBitmap := (Picture.Graphic as TBitmap);

  pf := NewBitmap.PixelFormat;
  { sȃrbg}bv̉\ꍇ́AI 24bit Color ɂ܂B}
  { ̗lȎ́Aʂ̐F 16bit Color ̏ꍇɂ悭܂B}
  if pf in [pfDevice, pfcustom] then
  begin
    NewBitmap.PixelFormat := pf24bit;
    pf := NewBitmap.PixelFormat;
  end;

  if pf <> pf24bit then
    NewBitmap.PixelFormat := pf24bit; // ꎞI24 rbgJ[ɂB

  term := 256 div Param;
  range := (256 - 1) div (Param - 1);
  for x := 0 to 255 do
  begin
    y := x div term;
    if y = 0 then // Param ̊K̐擪
      ColorMap[x] := 0
    else if y >= Param - 1 then // Param ̊K̍ŏI
      ColorMap[x] := 255
    else
      ColorMap[x] := y * range;
  end;

  for y := 0 to NewBitmap.Height - 1 do
  begin
    P := NewBitmap.ScanLine[y];
    for x := 0 to NewBitmap.Width - 1 do
    begin
      P[x].B := ColorMap[P[x].B];
      P[x].G := ColorMap[P[x].G];
      P[x].R := ColorMap[P[x].R];
    end;
  end;

  if pf in [pf8bit, pf32bit] then
    NewBitmap.PixelFormat := pf; // ̏ꍇ́AƂ̃rbg̃J[ɖ߂B

  Invalidate;

  Amended; // OnAmended CxgŔ
end;

{ rbg}bv摜 6 ނ̕@ 256 FɌF܂B}
{ Picture.Graphic is TBitmap łȂꍇсA256 F 8 rbgȉ }
{ J[̏ꍇ́A܂BParam ɂ́AF̕@ TReduceType }
{ w肵ĉBTReduceType ́Aȉ̗lɒ`Ă܂B}
{  TReduceType = (rdcOctree,      // Octree ŌF }
{                 rdcMedianCut,   // MedianCut ŌF }
{                 rdcMedianCutV,  // MedianCut + UŌF }
{                 rdcMedianCutE,  // MedianCut + 덷gUŌF }
{                 rdcMedianCutVE, // MedianCut + U + 덷gUŌF }
{                 rdcStaticE);    // Œpbg + 덷gUŌF }
procedure TTurboImage.Reduce(Param: TReduceType);
var
  NewBitmap: TBitmap;
  OldBitmap: TBitmap;
begin
  FKind := 'Reduce'; // ␳̎ނ FKind ɃZbgB(\bh)
  Amend;             // OnAmend CxgŔ

  if (not (Param in [rdcOctree, rdcMedianCut, rdcMedianCutV,
   rdcMedianCutE, rdcMedianCutVE, rdcStaticE])) or (BitCount <= 8) then
    Exit; // 8 rbgȉ̃J[̏ꍇ́AȂB

  OldBitmap := (Picture.Graphic as TBitmap);

  OldBitmap.PixelFormat := pf24bit; // I 24bit Color ɂĂ܂B
  NewBitmap := Nil;

  case Param of
    rdcOctree: NewBitmap := ReduceColorsByOctree(OldBitmap, 256);
    rdcMedianCut: NewBitmap := ReduceColorsByMedianCut(OldBitmap, 8);
    rdcMedianCutV: NewBitmap := ReduceColorsByMedianCutV(OldBitmap, 8);
    rdcMedianCutE: NewBitmap := ReduceColorsByMedianCutED(OldBitmap, 8);
    rdcMedianCutVE: NewBitmap := ReduceColorsByMedianCutVED(OldBitmap, 8);
    rdcStaticE: NewBitmap := StaticErrorDefusion(OldBitmap);
  end;

  try
    Picture.Graphic := NewBitmap;
  finally
    NewBitmap.Free;
  end;

  Amended; // OnAmended CxgŔ
end;

{ rbg}bv摜𔽓]\܂B}
{ Picture.Graphic is TBitmap łȂꍇ́A܂B}
procedure TTurboImage.Reverse;
var
  NewBitmap: TBitmap;
  x, y, i: Integer;
  w, h: Integer;
  OldBitmap: TBitmap;
  BC: Integer;
  Bits: Byte;
  Index: Integer;
  SourceScanline, DestScanline: array of Pointer;
begin
  FKind := 'Reverse'; // ␳̎ނ FKind ɃZbgB(\bh)
  Amend;              // OnAmend CxgŔ

  if PictureType <> picBitmap then
    Exit;

  Picture.Bitmap.HandleType := bmDIB;

  OldBitmap := (Picture.Graphic as TBitmap);

  { sȃrbg}bv̉\ꍇ́AI 24bit Color ɂ܂B}
  { ̗lȎ́Aʂ̐F 16bit Color ̏ꍇɂ悭܂B}
  if OldBitmap.PixelFormat in [pfDevice, pfcustom] then
    OldBitmap.PixelFormat := pf24bit;

  BC := BitCount;
  if not (BC in [1, 4, 8, 16, 24, 32]) then
    Exit;

  NewBitmap := TBitmap.Create;
  try
    w := OldBitmap.Width;
    h := OldBitmap.Height;

    NewBitmap.PixelFormat := OldBitmap.PixelFormat;
    NewBitmap.Width := w;
    NewBitmap.Height := h;
    NewBitmap.Palette := CopyPalette(OldBitmap.Palette);

    SetLength(SourceScanline, h);
    SetLength(DestScanline, h);
    for i := 0 to h - 1 do
      SourceScanline[i] := OldBitmap.Scanline[i];

    for i := 0 to h - 1 do
      DestScanline[i] := NewBitmap.Scanline[i];

    for y := 0 to h - 1 do
    begin
      for x := 0 to w - 1 do
      begin
        case BC of
          32: PDWordArray(DestScanline[y])^[x] :=
                PDWordArray(SourceScanline[y])^[w - 1 - x];
          24: PTripleArray(DestScanline[y])^[x] :=
                PTripleArray(SourceScanline[y])^[w - 1 - x];
          16: PWordArray(DestScanline[y])^[x] :=
                PWordArray(SourceScanline[y])^[w - 1 - x];
          8: PByteArray(DestScanline[y])^[x] :=
                PByteArray(SourceScanline[y])^[w - 1 - x];
          4:
          begin
            Index := w - 1 - x;
            Bits := PByteArray(SourceScanline[y])^[Index div 2];
            Bits := (Bits shr (4 * (1 - Index mod 2))) and $0f;
            PByteArray(DestScanline[y])^[x div 2] :=
             (PByteArray(DestScanline[y])^[x div 2] and
             not ($f0 shr (4 * (x mod 2)))) or
             (Bits shl (4 * (1 - x mod 2)));
          end;
          1:
          begin
            Index := w - 1 - x;
            Bits := PByteArray(SourceScanline[y])^[Index div 8];
            Bits := (Bits shr (7 - Index mod 8)) and $01;
            PByteArray(DestScanline[y])^[x div 8] :=
             (PByteArray(DestScanline[y])^[x div 8] and
             not ($80 shr (x mod 8))) or
             (Bits shl (7 - x mod 8));
          end;
        end;
      end;
    end;
    Picture.Graphic := NewBitmap;
  finally
    NewBitmap.Free;
  end;

  Invalidate;

  Amended; // OnAmended CxgŔ
end;

{ rbg}bv摜ZsAɕϊ܂B}
{ Picture.Graphic is TBitmap łȂꍇсA256 F 8 rbgȉ }
{ J[̏ꍇ́A܂B}
procedure TTurboImage.Sepia;
var
  NewBitmap: TBitmap;
  x, y: Integer;
  P: PTripleArray;
  pf: TPixelFormat;
  Col: Integer;
  BMap: array[0..255] of Byte;
  GMap: array[0..255] of Byte;
  RMap: array[0..255] of Byte;
  SBMap: array[0..255] of Byte;
  SGMap: array[0..255] of Byte;
begin
  FKind := 'Sepia'; // ␳̎ނ FKind ɃZbgB(\bh)
  Amend;            // OnAmend CxgŔ

  if BitCount < 8 then // 8 rbgȉ̃J[̏ꍇ́AȂB
    Exit;

  NewBitmap := (Picture.Graphic as TBitmap);

  pf := NewBitmap.PixelFormat;
  { sȃrbg}bv̉\ꍇ́AI 24bit Color ɂ܂B}
  { ̗lȎ́Aʂ̐F 16bit Color ̏ꍇɂ悭܂B}
  if pf in [pfDevice, pfcustom] then
  begin
    NewBitmap.PixelFormat := pf24bit;
    pf := NewBitmap.PixelFormat;
  end;

  if pf <> pf24bit then
    NewBitmap.PixelFormat := pf24bit; // ꎞI24 rbgJ[ɂB

  for x := 0 to 255 do
  begin
    BMap[x] := (x * 117) shr 10;
    GMap[x] := (x * 601) shr 10;
    RMap[x] := (x * 306) shr 10;
    SBMap[x] := (x * 619) shr 10;
    SGMap[x] := (x * 853) shr 10;
  end;

  for y := 0 to NewBitmap.Height - 1 do
  begin
    P := NewBitmap.ScanLine[y];
    for x := 0 to NewBitmap.Width - 1 do
    begin
      Col := BMap[P[x].B] + GMap[P[x].G] + RMap[P[x].R];
      P[x].B := SBMap[Col];
      P[x].G := SGMap[Col];
      P[x].R := Col;
    end;
  end;

  if pf in [pf8bit, pf32bit] then
    NewBitmap.PixelFormat := pf; // ̏ꍇ́AƂ̃rbg̃J[ɖ߂B

  Invalidate;

  Amended; // OnAmended CxgŔ
end;

procedure TTurboImage.SetPictureType(const Value: TPictureType);
var
  PicType: TPictureType;
  Bmp: TBitmap;
  Meta: TMetafile;
  MfCanvas: TMetafileCanvas;
  MS: TSize;
begin
  PicType := PictureType; // ̃OtCbNf[^̎

  if (Value = PicType) or (Value in [picIcon, picUnknown]) then
    Exit
  else if Value = picNil then
  begin
    Picture := Nil;       // OtCbNf[^j
    Exit;
  end;

  { ܂݂̃OtCbNf[^rbg}bvf[^ɕϊB}
  Bmp := TBitmap.Create;
  try
    if PicType = picBitmap then
      Bmp.Assign(Picture.Graphic)
    else if PicType in [picMetafile, picIcon, picUnknown] then
    begin
      Bmp.Width := Picture.Graphic.Width;
      Bmp.Height := Picture.Graphic.Height;
      Bmp.Canvas.Draw(0, 0, Picture.Graphic);
    end;

    { ɕϊꂽrbg}bvf[^^[Qbgf[^ɕϊB}
    if Value = picBitmap then
      Picture.Graphic := Bmp
    else if Value = picMetafile then
    begin
      MS := MScaleFactor; // ^t@C̃XP[t@N^
      Meta := TMetafile.Create;
      try
        Meta.Width := Picture.Graphic.Width;
        Meta.Height := Picture.Graphic.Height;
        MfCanvas := TMetafileCanvas.Create(Meta, GetDC(0));
        try
          MfCanvas.Draw(0, 0, Bmp);
        finally
          MfCanvas.Free;
        end;
        { `̑傫XN[foCXɂ悤ɂB(Inch <> 0) }
        Meta.Inch := 1;
        { TCY␳B}
        Meta.Width := Meta.Width * 100 div MS.cx;
        Meta.Height := Meta.Height * 100 div MS.cy;
        Picture.Graphic := Meta;
      finally
        Meta.Free;
      end;
    end;
  finally
    Bmp.Free;
  end;
end;

{ rbg}bv摜ϕ@ŏk܂B}
{ Picture.Graphic is TBitmap łȂꍇ́A܂B}
{ ParamWidth, ParamHeight ́Aŏk̐V傫łB}
procedure TTurboImage.Shrink(ParamWidth: Integer; ParamHeight: Integer);
var
  NewBitmap: TBitmap;
  pf: TPixelFormat;
  OldBitmap: TBitmap;
begin
  FKind := 'Shrink'; // ␳̎ނ FKind ɃZbgB(\bh)
  Amend;           // OnAmend CxgŔ

  if PictureType <> picBitmap then
    Exit;

  Picture.Bitmap.HandleType := bmDIB;

  OldBitmap := (Picture.Graphic as TBitmap);

  pf := OldBitmap.PixelFormat;
  { sȃrbg}bv̉\ꍇ́AI 24bit Color ɂ܂B}
  { ̗lȎ́Aʂ̐F 16bit Color ̏ꍇɂ悭܂B}
  if pf in [pfDevice, pfcustom] then
  begin
    OldBitmap.PixelFormat := pf24bit;
    pf := OldBitmap.PixelFormat;
  end;

  if (ParamWidth > OldBitmap.Width) or (ParamHeight > OldBitmap.Height) then
    Exit;

  NewBitmap := Shrink_(OldBitmap, ParamWidth, ParamHeight);
  try
    if not (pf in [pf15bit, pf16bit, pf24bit]) then
      NewBitmap.PixelFormat := pf; // ̏ꍇ́AƂ̃rbg̃J[ɖ߂B
    Picture.Graphic := NewBitmap;
  finally
    NewBitmap.Free;
  end;

  Invalidate;

  Amended; // OnAmended CxgŔ
end;

{ ϕ@Ńrbg}bvk֐ }
{ @j@(\tgoNpubVOs) }
{ Delphi Graphic Secrets }
{ Know-how & Libraries }
{ pĂ܂B@jAL܂B}
function TTurboImage.Shrink_(SrcBitmap: TBitmap; NewWidth, NewHeight: Integer): TBitmap;
var
  NewBitmap, SourceBitmap: TBitmap;
  x, y: Integer; // ϊ x, y Wl
  SourceWidth, SourceHeight: Integer; // ϊ̃rbg}bv̑傫
  RectTop, RectLeft, RectRight, RectBottom: Double; // ϊɓeꂽϊsNZ̈ʒu
  w, h: Double; // ϊɓeꂽϊsNZƕϊsNZĂ镔̑傫
  Ratio: Single; // k(ʐϔ)
  pSourceScan, pNewScan: PTripleArray; // XLC|C^
  XRatio, YRatio: Double; // XAY̏k
  SourceScans, NewScans: array of PTripleArray; // XLC|C^̃LbV
  Pixel: TDoubleTriple; // ϊ̃sNZn
  SourcePixel: TTriple; // ϊƂ̃sNZl
  i, j: Integer;
begin
  SourceWidth := SrcBitmap.Width; SourceHeight := SrcBitmap.Height;
  assert((SourceWidth > 0) and (SourceHeight > 0));
  Ratio := SourceWidth * Sourceheight / NewWidth / NewHeight;
  XRatio := SourceWidth / NewWidth;
  YRatio := SourceHeight / NewHeight;
  NewBitmap := TBitmap.Create;
  try
    // ϊ rbg}bv
    NewBitmap.PixelFormat := pf24bit;
    NewBitmap.Width := NewWidth; NewBitmap.Height := NewHeight;

    // ϊtJ[ɂ
    SourceBitmap := TBitmap.Create;
    try
      SourceBitmap.Assign(SrcBitmap);
      SourceBitmap.PixelFormat := pf24Bit;

      // XLC|C^̃LbV
      SetLength(SourceScans, SourceHeight);
      SetLength(NewScans, NewHeight);

      for i := 0 to SourceHeight - 1 do
        SourceScans[i] := SourceBitmap.ScanLine[i];

      for i := 0 to NewHeight - 1 do
        NewScans[i] := NewBitmap.Scanline[i];

      for y := 0 to NewHeight - 1 do
      begin
        // ϊXLC|C^𓾂
        pNewScan := NewScans[y];
        for x := 0 to NewWidth - 1 do
        begin
          // ϊsNZϊɓeB
          RectLeft   := x * XRatio;
          RectTop    := y * YRatio;
          RectRight  := (x + 1) * XRatio - 0.000001;
          RectBottom := (y + 1) * YRatio - 0.000001;

          // ϊɓeꂽϊsNZƌĂ
          // ϊsNZIяoϕ
          Pixel.R := 0; Pixel.G := 0; Pixel.B := 0;

          for j := Floor(RectTop) to Floor(RectBottom) do
          begin
            pSourceScan:= SourceScans[j];
            for i := Floor(RectLeft) to Floor(RectRight) do
            begin
              SourcePixel := pSourceScan[i];

              // eꂽsNZƕϊsNŽĂ
              // ̑傫߂
              if (RectLeft < i) and ((i + 1) < RectRight) then
                w := 1
              else if (i <= RectLeft) and ((i + 1) < RectRight) then
                w := 1 - (RectLeft - i)
              else if (RectLeft < i) and (RectRight <= (i + 1)) then
                w := RectRight - i
              else
                w := RectRight - RectLeft;

              if (RectTop < j) and ((j + 1) < RectBottom) then
                h := 1
              else if (j <= RectTop) and ((j + 1) < RectBottom) then
                h := 1 - (RectTop - j)
              else if (RectTop < j) and (RectBottom < (j + 1)) then
                h := RectBottom - j
              else
                h := RectBottom - RectTop;

              // ϊ@1 sNZ@ϕ
              Pixel.R := Pixel.R + w * h * SourcePixel.R;
              Pixel.G := Pixel.G + w * h * SourcePixel.G;
              Pixel.B := Pixel.B + w * h * SourcePixel.B;
            end;
          end;
          // ϕl畽ϒlߕϊɑ
          pNewScan[x].R := Round(Pixel.R / Ratio);
          pNewScan[x].G := Round(Pixel.G / Ratio);
          pNewScan[x].B := Round(Pixel.B / Ratio);
        end;
      end;
    finally
      SourceBitmap.Free;
    end;
  except
    NewBitmap.Free;
    Raise;
  end;
  Result := NewBitmap;
end;

{ rbg}bv摜̗֊so邢́A֊s`sȂ܂B}
{ Picture.Graphic is TBitmap łȂꍇсA256 F 8 rbgȉ }
{ J[̏ꍇ́A܂B֊s̋̓x Param ́A1 ` 100 }
{ ͈̔͂Ŏw肵ĉBDraw = True Ȃ֊s` False Ȃ֊so }
{ sȂ܂B}
procedure TTurboImage.Sobel(Param: Integer; Draw: Boolean);
const
  HFilter: array[0..8] of Integer = (1, 0, -1, // ̃GbWo
                                     2, 0, -2,
                                     1, 0, -1);

  VFilter: array[0..8] of Integer = (1,  2,  1, // c̃GbWo
                                     0,  0,  0,
                                    -1, -2, -1);

var
  NewBitmap: TBitmap;
  x, y, i: Integer;
  xx, yy: Integer;
  w, h: Integer;
  Blue, Green, Red: Integer;
  rh, gh, bh: Integer;
  rv, gv, bv: Integer;
  rr, gg, bb: Integer;
  Col: Integer;
  pf: TPixelFormat;
  OldBitmap: TBitmap;
  SourceMatrix, DestMatrix: array of PTripleArray;
begin
  FKind := 'Sobel'; // ␳̎ނ FKind ɃZbgB(\bh)
  Amend;            // OnAmend CxgŔ

  if (not (Param in [1..100])) or (BitCount < 8) then
    Exit; // 8 rbgȉ̃J[̏ꍇ́AȂB

  OldBitmap := (Picture.Graphic as TBitmap);

  pf := OldBitmap.PixelFormat;
  { sȃrbg}bv̉\ꍇ́AI 24bit Color ɂ܂B}
  { ̗lȎ́Aʂ̐F 16bit Color ̏ꍇɂ悭܂B}
  if pf in [pfDevice, pfcustom] then
  begin
    OldBitmap.PixelFormat := pf24bit;
    pf := OldBitmap.PixelFormat;
  end;

  if pf <> pf24bit then
    OldBitmap.PixelFormat := pf24bit; // ꎞI24 rbgJ[ɂB

  NewBitmap := TBitmap.Create;
  try
    w := OldBitmap.Width;
    h := OldBitmap.Height;

    NewBitmap.PixelFormat := OldBitmap.PixelFormat;
    NewBitmap.Width := w;
    NewBitmap.Height := h;
    NewBitmap.Palette := CopyPalette(OldBitmap.Palette);

    SetLength(SourceMatrix, h);
    SetLength(DestMatrix, h);
    for i := 0 to h - 1 do
      SourceMatrix[i] := OldBitmap.Scanline[i];

    for i := 0 to h - 1 do
      DestMatrix[i] := NewBitmap.Scanline[i];

    for y := 1 to h - 2 do
    begin
      for x := 1 to w - 2 do
      begin
        rh := 0; gh := 0; bh := 0;
        rv := 0; gv := 0; bv := 0;
        i := 0;
        for yy := -1 to 1 do
        begin
          for xx := -1 to 1 do
          begin
            Blue := SourceMatrix[y + yy][x + xx].B;
            Green := SourceMatrix[y + yy][x + xx].G;
            Red := SourceMatrix[y + yy][x + xx].R;
            bh := bh + Blue * HFilter[i];
            gh := gh + Green * HFilter[i];
            rh := rh + Red * HFilter[i];
            bv := bv + Blue * VFilter[i];
            gv := gv + Green * VFilter[i];
            rv := rv + Red * VFilter[i];
            Inc(i);
          end;
        end;

        bb := (bh * bh + bv * bv) * Param div 100;
        gg := (gh * gh + gv * gv) * Param div 100;
        rr := (rh * rh + rv * rv) * Param div 100;
        bb := Round(Sqrt(bb)); if bb > 255 then bb := 255;
        gg := Round(Sqrt(gg)); if gg > 255 then gg := 255;
        rr := Round(Sqrt(rr)); if rr > 255 then rr := 255;
        Col := 255 - (rr or gg or bb);
        if Draw = True then // ֊s`
        begin
          DestMatrix[y][x].B := Col and SourceMatrix[y][x].B;
          DestMatrix[y][x].G := Col and SourceMatrix[y][x].G;
          DestMatrix[y][x].R := Col and SourceMatrix[y][x].R;
        end
        else // ֊so
        begin
          DestMatrix[y][x].B := Col;
          DestMatrix[y][x].G := Col;
          DestMatrix[y][x].R := Col;
        end;
      end;
    end;

    for x := 1 to w - 2 do
    begin
      DestMatrix[0][x] := DestMatrix[1][x];
      DestMatrix[h - 1][x] := DestMatrix[h - 2][x];
    end;

    for y := 0 to h - 1 do
    begin
      DestMatrix[y][0] := DestMatrix[y][1];
      DestMatrix[y][w - 1] := DestMatrix[y][w - 2];
    end;

    if pf in [pf8bit, pf32bit] then
      NewBitmap.PixelFormat := pf; // ̏ꍇ́AƂ̃rbg̃J[ɖ߂B
    Picture.Graphic := NewBitmap;
  finally
    NewBitmap.Free;
  end;

  Invalidate;

  Amended; // OnAmended CxgŔ
end;

{ rbg}bv摜̖邳(Kl)̕z FromMin ` FromMax  }
{ ToMin ` ToMax ɔ͈͕ϊ܂Be͈̔͂́A0 ` 255 ŁA}
{ ܂ FromMin < FromMax, ToMin < ToMax łȂ΂Ȃ܂B}
{ Picture.Graphic is TBitmap łȂꍇсA256 F 8 rbgȉ }
{ J[̏ꍇ́A܂BSpread() ͓ Linear() Ăяo }
{ ܂B܂AAutomatic() ͓ł Spread() ĂяoĂ܂B}
procedure TTurboImage.Spread(FromMin: Integer; FromMax: Integer; ToMin: Integer; ToMax:Integer);
var
  Param: Integer;
  ParamConst: Integer;
begin
  FKind := 'Spread'; // ␳̎ނ FKind ɃZbgB(\bh)
  Amend;             // OnAmend CxgŔ

  if (FromMin < 0) or (FromMin > 255) or (FromMax < 0) or (FromMax > 255)
   or (ToMin < 0) or (ToMin > 255) or (ToMax < 0) or (ToMax > 255)
   or (FromMin >= FromMax) or (ToMin >= ToMax) then
    Exit;

  Param := (ToMax - ToMin) * 100 div (FromMax - FromMin);
  ParamConst := ToMax - FromMax * Param div 100;

  Linear(Param, ParamConst);

  Amended; // OnAmended CxgŔ
end;

{ rbg}bv摜 Bi-Linear & ϕ@Ŋgk܂B}
{ Picture.Graphic is TBitmap łȂꍇ́A܂B}
{ ParamWidth, ParamHeight ́AŃTCYύX̐V傫łB}
procedure TTurboImage.Stretches(ParamWidth: Integer; ParamHeight: Integer);
var
  NewBitmap: TBitmap;
  pf: TPixelFormat;
  OldBitmap: TBitmap;
begin
  FKind := 'Stretches'; // ␳̎ނ FKind ɃZbgB(\bh)
  Amend;           // OnAmend CxgŔ

  if PictureType <> picBitmap then
    Exit;

  Picture.Bitmap.HandleType := bmDIB;

  OldBitmap := (Picture.Graphic as TBitmap);

  pf := OldBitmap.PixelFormat;
  { sȃrbg}bv̉\ꍇ́AI 24bit Color ɂ܂B}
  { ̗lȎ́Aʂ̐F 16bit Color ̏ꍇɂ悭܂B}
  if pf in [pfDevice, pfcustom] then
  begin
    OldBitmap.PixelFormat := pf24bit;
    pf := OldBitmap.PixelFormat;
  end;

  NewBitmap := Stretches_(OldBitmap, ParamWidth, ParamHeight);
  try
    if not (pf in [pf15bit, pf16bit, pf24bit]) then
      NewBitmap.PixelFormat := pf; // ̏ꍇ́AƂ̃rbg̃J[ɖ߂B
    Picture.Graphic := NewBitmap;
  finally
    NewBitmap.Free;
  end;

  Invalidate;

  Amended; // OnAmended CxgŔ
end;

{ Bi-Linear & ϕ@Ńrbg}bvgk֐ }
{ @j@(\tgoNpubVOs) }
{ Delphi Graphic Secrets }
{ Know-how & Libraries }
{ pĂ܂B@jAL܂B}
function TTurboImage.Stretches_(SrcBitmap: TBitmap; NewWidth, NewHeight: Integer): TBitmap;
var
  NewBitmap, SourceBitmap: TBitmap;
  x, y: Integer; // ϊ x, y Wl
  SourceWidth, SourceHeight: Integer; // ϊ̃rbg}bv̑傫
  RectTop, RectLeft, RectRight, RectBottom: Double; // ϊɓeꂽϊsNZ̈ʒu
  w, h: Double; // ϊɓeꂽϊsNZƕϊsNZĂ镔̑傫
  XAve, YAve: Double; // ϊɓeꂽϊsNZƕϊsNZĂ镔̒SʒuBϊsNZ̍オ
  a, b, c, d: TTriple; // x, y ϊɓé@ߖT̃sNZ4_
  p, q, r, s: TDoubleTriple; // ߖT̃sNZ4_狁߂ Bi-Linear ̌W
  Ratio: Double; // g嗦̋t(ʐϔ)
  pSourceScan1, pSourceScan2, pNewScan: PTripleArray; // XLC|C^
  XRatio, YRatio: Double; // XAY̊g嗦̋tB
  SourceScans, NewScans: array of PTripleArray; // XLC̃LbV
  Pixel: TDoubleTriple; // ϊ̃sNZl
  i, j: Integer;
begin
  SourceWidth := SrcBitmap.Width; SourceHeight := SrcBitmap.Height;
  assert((SourceWidth > 0) and (SourceHeight > 0));
  Ratio := SourceWidth * Sourceheight / NewWidth / NewHeight;
  XRatio := SourceWidth / NewWidth;
  YRatio := SourceHeight / NewHeight;

  // ϊ rbg}bv
  NewBitmap := TBitmap.Create;
  try
    NewBitmap.PixelFormat := pf24bit;
    NewBitmap.Width := NewWidth; NewBitmap.Height := NewHeight;

    // ϊtJ[ɂ
    SourceBitmap := TBitmap.Create;
    try
      SourceBitmap.Assign(SrcBitmap);
      SourceBitmap.PixelFormat := pf24Bit;

      // XLC|C^̃LbV
      SetLength(SourceScans, SourceHeight);
      SetLength(NewScans, NewHeight);

      for i := 0 to SourceHeight - 1 do
        SourceScans[i] := SourceBitmap.ScanLine[i];

      for i := 0 to NewHeight - 1 do
        NewScans[i] := NewBitmap.Scanline[i];

      for y := 0 to NewHeight - 1 do
      begin
        // ϊXLC|C^𓾂
        pNewScan := NewScans[y];

        for x := 0 to NewWidth - 1 do
        begin
          // ϊsNZϊɓe(0.5 Â炷)B
          RectLeft   := x * XRatio - 0.5;
          RectTop    := y * YRatio - 0.5;
          RectRight  := (x + 1) * XRatio - 0.500001;
          RectBottom := (y + 1) * YRatio - 0.500001;

          // ϊɓeꂽϊsNZƌĂ
          // ϊsNZԂ Bi-Linera ȖʂIяoϕ
          Pixel.R := 0; Pixel.G := 0; Pixel.B := 0;

          for j := Floor(RectTop) to Floor(RectBottom) do
          begin
            // Bi-Linear Ȗʂ̏Ɖ̃sNZ̃XLC߂
            // rbg}bv̒[l
            if j < 0 then
              pSourceScan1 := SourceScans[0]
            else
              pSourceScan1 := SourceScans[j];
            if j + 1 > SourceHeight - 1 then
              pSourceScan2 := SourceScans[SourceHeight - 1]
            else
              pSourceScan2 := SourceScans[j + 1];

            for i := Floor(RectLeft) to Floor(RectRight) do
            begin
              // Bi-Linear Ȗʂ4̃sNZ𓾂
              // rbg}bv̒[l
              if i < 0 then
              begin
                a := pSourceScan1[0];
                c := pSourceScan2[0];
              end
              else
              begin
                a := pSourceScan1[i];
                c := pSourceScan2[i];
              end;

              if i + 1 > SourceWidth - 1 then
              begin
                b := pSourceScan1[SourceWidth - 1];
                d := pSourceScan2[SourceWidth - 1];
              end
              else
              begin
                b := pSourceScan1[i + 1];
                d := pSourceScan2[i + 1];
              end;

              // Bi-Linear Ȗʂ̌WvZB
              p.R := b.R - a.R;
              s.R := a.R;
              r.R := c.R - a.R;
              q.R := d.R + a.R - b.R - c.R;
              p.G := b.G - a.G;
              s.G := a.G;
              r.G := c.G - a.G;
              q.G := d.G + a.G - b.G - c.G;
              p.B := b.B - a.B;
              s.B := a.B;
              r.B := c.B - a.B;
              q.B := d.B + a.B - b.B - c.B;

              //eꂽsNZ Bi-Linear Ȗʂ̌Ă镔
              //傫ƒSʒu߂
              if (RectLeft < i) and ((i + 1) < RectRight) then
              begin
                w := 1;
                XAve := 0.5;
              end
              else if (i <= RectLeft) and ((i + 1) < RectRight) then
              begin
                w := 1 - (RectLeft - i);
                XAve := (RectLeft - i + 1) / 2;
              end
              else if (RectLeft < i) and (RectRight <= (i + 1)) then
              begin
                w := RectRight - i;
                XAve := w / 2;
              end
              else
              begin
                w := RectRight - RectLeft;
                XAve := ((RectRight - i) + (RectLeft - i)) / 2;
              end;

              if (RectTop < j) and ((j + 1) < RectBottom) then
              begin
                h := 1;
                YAve := 0.5;
              end
              else if (j <= RectTop) and ((j + 1) < RectBottom) then
              begin
                h := 1 - (RectTop - j);
                YAve := (RectTop - j + 1) / 2;
              end
              else if (RectTop < j) and (RectBottom < (j+1)) then
              begin
                h := RectBottom - j;
                YAve := h / 2;
              end
              else
              begin
                h := RectBottom - RectTop;
                YAve := ((RectBottom - j) + (RectTop - j)) / 2;
              end;

              // eꂽsNZ Bi-Linear Ȗʂ̌Ă镔
              // ϕ
              Pixel.R := Pixel.R +
                w * h * (p.R * XAve + q.R * XAve * YAve + r.R * YAve + s.R);
              Pixel.G := Pixel.G +
                w * h * (p.G * XAve + q.G * XAve * YAve + r.G * YAve + s.G);
              Pixel.B := Pixel.B +
                w * h * (p.B * XAve + q.B * XAve * YAve + r.B * YAve + s.B);
            end;
          end;
          // ϕl畽ϒlߕϊɑB
          pNewScan[x].R := Round(Pixel.R / Ratio);
          pNewScan[x].G := Round(Pixel.G / Ratio);
          pNewScan[x].B := Round(Pixel.B / Ratio);
        end;
      end;
    finally
      SourceBitmap.Free;
    end;
  except
    NewBitmap.Free;
    Raise;
  end;
  Result := NewBitmap;
end;

{ 摜g~O܂BPicture.Graphic is TBitmap  TMetafile ̏ꍇ̂ }
{ g~OsȂ܂Bg~O͈ ParamR 摜͈̔͂𒴂Ă }
{ ꍇ́AsȂ܂BParamG ́AParamR ǂ͈̔͂ɂ邩w }
{  ParamG = True ̏ꍇ́APicture.Graphic ͈̔͂ɂA܂ }
{ ParamG = False ̏ꍇ́ARg[͈̔͂ɂ܂Bʏ́AParamG }
{ ́AFalse ŗǂƎv܂BStretch = True ꍇ́A̎̉摜̏cE }
{ ꂼ̊gEkɂ킹ăg~OcEg~OOƓ }
{ 䗦ɂȂlɃRg[̃TCY𒲐܂B}
procedure TTurboImage.Trimming(ParamR: TRect; ParamG: Boolean);
var
  NewBitmap: TBitmap;
  OldBitmap: TBitmap;
  NewMf: TMetafile;
  OldMf: TMetafile;
  NewMfCanvas: TMetafileCanvas;
  RectC, RectG, RectN: TRect;
  asz, srh: Boolean;
  CW, CH: Integer;
  GW, GH: Integer;
  NW, NH: Integer;
  MS: TSize;
begin
  FKind := 'Trimming'; // ␳̎ނ FKind ɃZbgB(\bh)
  Amend;               // OnAmend CxgŔ

  if not (PictureType in [picBitmap, picMetafile]) then
    Exit;

  RectC := ParamR;
  RectG := ParamR;

  CW := Width;                  // Rg[̕
  CH := Height;                 // Rg[̍
  GW := Picture.Graphic.Width;  // Picture.Graphic ̕
  GH := Picture.Graphic.Height; // Picture.Graphic ̍
  NW := Width;                  // g~ÕRg[̕
  NH := Height;                 // g~ÕRg[̍

  if (AutoSize = False) and (Stretch = True) then // Xgb`[h̏ꍇ
  begin
    if ParamG = False then // Rg[͈̔͂ɂꍇ
    begin
      RectG.Left := ((RectC.Left shl 10) * GW div CW) shr 10;
      RectG.Top := ((RectC.Top shl 10) * GH div CH) shr 10;
      RectG.Right := ((RectC.Right shl 10) * GW div CW) shr 10;
      RectG.Bottom := ((RectC.Bottom shl 10) * GH div CH) shr 10;
    end
    else // Picture.Graphic ͈̔͂ɂꍇ
    begin
      RectC.Left := ((RectG.Left shl 10) * CW div GW) shr 10;
      RectC.Top := ((RectG.Top shl 10) * CH div GH) shr 10;
      RectC.Right := ((RectG.Right shl 10) * CW div GW) shr 10;
      RectC.Bottom := ((RectG.Bottom shl 10) * CH div GH) shr 10;
    end;
    NW := RectC.Right - RectC.Left + 1; // g~ÕRg[̕
    NH := RectC.Bottom - RectC.Top + 1; // g~ÕRg[̍
  end;

  if (RectG.Left < 0) or (RectG.Top < 0) or
   (RectG.Right >= GW) or (RectG.Bottom > GH) then
    Exit;

  { RectG ̑傫␳Ă }
  RectG.Right := RectG.Right + 1;
  RectG.Bottom := RectG.Bottom + 1;

  RectN := Rect(0, 0, RectG.Right - RectG.Left, RectG.Bottom - RectG.Top);

  asz := AutoSize;
  srh := Stretch;
  AutoSize := False;
  Stretch := False;

  if PictureType = picBitmap then
  begin
    OldBitmap := (Picture.Graphic as TBitmap);
    OldBitmap.HandleType := bmDIB;
    { sȃrbg}bv̉\ꍇ́AI 24bit Color ɂ܂B}
    { ̗lȎ́Aʂ̐F 16bit Color ̏ꍇɂ悭܂B}
    if OldBitmap.PixelFormat in [pfDevice, pfcustom] then
      OldBitmap.PixelFormat := pf24bit;
    NewBitmap := TBitmap.Create;
    try
      NewBitmap.HandleType := bmDIB;
      NewBitmap.PixelFormat := OldBitmap.PixelFormat;
      NewBitmap.Width := RectN.Right;
      NewBitmap.Height := RectN.Bottom;
      NewBitmap.Palette := CopyPalette(OldBitmap.Palette);
      NewBitmap.Canvas.CopyRect(RectN, OldBitmap.Canvas, RectG);
      Width := NW;
      Height := NH;
      Picture.Graphic := NewBitmap;
    finally
      NewBitmap.Free;
    end;
  end
  else if PictureType = picMetafile then
  begin
    MS := MScaleFactor; // ^t@C̃XP[t@N^
    OldMf := (Picture.Graphic as TMetafile);
    NewMf := TMetafile.Create;
    try
      { ^t@C̃XP[t@N^gĕ␳ăTCYw肷B}
      NewMf.Width := RectN.Right;
      NewMf.Height := RectN.Bottom;
      NewMf.Palette := CopyPalette(OldMf.Palette);
      NewMfCanvas := TMetafileCanvas.Create(NewMf, GetDC(0));
      try
        NewBitmap := TBitmap.Create;
        try
          NewBitmap.HandleType := bmDIB;
          NewBitmap.PixelFormat := pf24bit;
          NewBitmap.Width := RectN.Right;
          NewBitmap.Height := RectN.Bottom;
          OldBitmap := TBitmap.Create;
          try
            OldBitmap.HandleType := bmDIB;
            OldBitmap.PixelFormat := pf24bit;
            OldBitmap.Width := Picture.Graphic.Width;
            OldBitmap.Height := Picture.Graphic.Height;
            OldBitmap.Canvas.Draw(0, 0, PicTure.Graphic);
            NewBitmap.Canvas.CopyRect(RectN, OldBitmap.Canvas, RectG);
          finally
            OldBitmap.Free;
          end;
          NewMfCanvas.Draw(0, 0, NewBitmap);
        finally
          NewBitmap.Free;
        end;
      finally
        NewMfCanvas.Free;
      end;
      { `̑傫XN[foCXɂ悤ɂB(Inch <> 0) }
      NewMf.Inch := 1;
      { TCY␳B}
      NewMf.Width := NewMf.Width * 100 div MS.cx;
      NewMf.Height := NewMf.Height * 100 div MS.cy;
      Width := NW;
      Height := NH;
      Picture.Graphic := NewMf;
    finally
      NewMf.Free;
    end;
  end;

  Stretch := srh;
  AutoSize := asz;

  Invalidate;

  Amended; // OnAmended CxgŔ
end;

{ rbg}bv摜 90 xPʂŉ]\܂B}
{ Picture.Graphic is TBitmap łȂꍇ́A܂B}
procedure TTurboImage.Turn(Param: Integer);
var
  NewBitmap: TBitmap;
  x, y, i: Integer;
  w, h: Integer;
  ww, hh: Integer;
  asz, srh: Boolean;
  OldBitmap: TBitmap;
  BC: Integer;
  Bits: Byte;
  Index: Integer;
  SourceScanline, DestScanline: array of Pointer;
begin
  FKind := 'Turn'; // ␳̎ނ FKind ɃZbgB(\bh)
  Amend;           // OnAmend CxgŔ

  if (PictureType <> picBitmap)
   or ((Param mod 360) = 0) or ((Param mod 90) <> 0) then
    Exit;

  Param := ((Param div 90) mod 4) * 90;
  if Param < 0 then
    Param := Param + 360;

  asz := AutoSize;
  srh := Stretch;
  AutoSize := False;
  Stretch := False;

  ww := Width;
  hh := Height;

  Picture.Bitmap.HandleType := bmDIB;

  OldBitmap := (Picture.Graphic as TBitmap);

  { sȃrbg}bv̉\ꍇ́AI 24bit Color ɂ܂B}
  { ̗lȎ́Aʂ̐F 16bit Color ̏ꍇɂ悭܂B}
  if OldBitmap.PixelFormat in [pfDevice, pfcustom] then
    OldBitmap.PixelFormat := pf24bit;

  BC := BitCount;
  if not (BC in [1, 4, 8, 16, 24, 32]) then
    Exit;

  NewBitmap := TBitmap.Create;
  try
    if Param = 180 then
    begin
      w := OldBitmap.Width;
      h := OldBitmap.Height;
    end
    else
    begin
      w := OldBitmap.Height;
      h := OldBitmap.Width;
    end;

    NewBitmap.PixelFormat := OldBitmap.PixelFormat;
    NewBitmap.Width := w;
    NewBitmap.Height := h;
    NewBitmap.Palette := CopyPalette(OldBitmap.Palette);

    if Param = 90 then
    begin
      SetLength(SourceScanline, w);
      SetLength(DestScanline, h);
      for i := 0 to w - 1 do
        SourceScanline[i] := OldBitmap.Scanline[i];

      for i := 0 to h - 1 do
        DestScanline[i] := NewBitmap.Scanline[i];

      for y := 0 to h - 1 do
      begin
        for x := 0 to w - 1 do
        begin
          case BC of
            32: PDWordArray(DestScanline[y])^[x] :=
                  PDWordArray(SourceScanline[w - 1 - x])^[y];
            24: PTripleArray(DestScanline[y])^[x] :=
                  PTripleArray(SourceScanline[w - 1 - x])^[y];
            16: PWordArray(DestScanline[y])^[x] :=
                  PWordArray(SourceScanline[w - 1 - x])^[y];
            8: PByteArray(DestScanline[y])^[x] :=
                  PByteArray(SourceScanline[w - 1 - x])^[y];
            4:
            begin
              Index := y;
              Bits := PByteArray(SourceScanline[w - 1 - x])^[Index div 2];
              Bits := (Bits shr (4 * (1 - Index mod 2))) and $0f;
              PByteArray(DestScanline[y])^[x div 2] :=
               (PByteArray(DestScanline[y])^[x div 2] and
               not ($f0 shr (4 * (x mod 2)))) or
               (Bits shl (4 * (1 - x mod 2)));
            end;
            1:
            begin
              Index := y;
              Bits := PByteArray(SourceScanline[w - 1 - x])^[Index div 8];
              Bits := (Bits shr (7 - Index mod 8)) and $01;
              PByteArray(DestScanline[y])^[x div 8] :=
               (PByteArray(DestScanline[y])^[x div 8] and
               not ($80 shr (x mod 8))) or
               (Bits shl (7 - x mod 8));
            end;
          end;
        end;
      end;
      Width := hh;
      Height := ww;
    end
    else if Param = 180 then
    begin
      SetLength(SourceScanline, h);
      SetLength(DestScanline, h);
      for i := 0 to h - 1 do
        SourceScanline[i] := OldBitmap.Scanline[i];

      for i := 0 to h - 1 do
        DestScanline[i] := NewBitmap.Scanline[i];

      for y := 0 to h - 1 do
      begin
        for x := 0 to w - 1 do
        begin
          case BC of
            32: PDWordArray(DestScanline[y])^[x] :=
                  PDWordArray(SourceScanline[h - 1 - y])^[w - 1 - x];
            24: PTripleArray(DestScanline[y])^[x] :=
                  PTripleArray(SourceScanline[h - 1 - y])^[w - 1 - x];
            16: PWordArray(DestScanline[y])^[x] :=
                  PWordArray(SourceScanline[h - 1 - y])^[w - 1 - x];
            8: PByteArray(DestScanline[y])^[x] :=
                  PByteArray(SourceScanline[h - 1 - y])^[w - 1 - x];
            4:
            begin
              Index := w - 1 - x;
              Bits := PByteArray(SourceScanline[h - 1 - y])^[Index div 2];
              Bits := (Bits shr (4 * (1 - Index mod 2))) and $0f;
              PByteArray(DestScanline[y])^[x div 2] :=
               (PByteArray(DestScanline[y])^[x div 2] and
               not ($f0 shr (4 * (x mod 2)))) or
               (Bits shl (4 * (1 - x mod 2)));
            end;
            1:
            begin
              Index := w - 1 - x;
              Bits := PByteArray(SourceScanline[h - 1 - y])^[Index div 8];
              Bits := (Bits shr (7 - Index mod 8)) and $01;
              PByteArray(DestScanline[y])^[x div 8] :=
               (PByteArray(DestScanline[y])^[x div 8] and
               not ($80 shr (x mod 8))) or
               (Bits shl (7 - x mod 8));
            end;
          end;
        end;
      end;
    end
    else if Param = 270 then
    begin
      SetLength(SourceScanline, w);
      SetLength(DestScanline, h);
      for i := 0 to w - 1 do
        SourceScanline[i] := OldBitmap.Scanline[i];

      for i := 0 to h - 1 do
        DestScanline[i] := NewBitmap.Scanline[i];

      for y := 0 to h - 1 do
      begin
        for x := 0 to w - 1 do
        begin
          case BC of
            32: PDWordArray(DestScanline[y])^[x] :=
                  PDWordArray(SourceScanline[x])^[h - 1 - y];
            24: PTripleArray(DestScanline[y])^[x] :=
                  PTripleArray(SourceScanline[x])^[h - 1 - y];
            16: PWordArray(DestScanline[y])^[x] :=
                  PWordArray(SourceScanline[x])^[h - 1 - y];
            8: PByteArray(DestScanline[y])^[x] :=
                  PByteArray(SourceScanline[x])^[h - 1 - y];
            4:
            begin
              Index := h - 1 - y;
              Bits := PByteArray(SourceScanline[x])^[Index div 2];
              Bits := (Bits shr (4*(1 - Index mod 2))) and $0f;
              PByteArray(DestScanline[y])^[x div 2] :=
               (PByteArray(DestScanline[y])^[x div 2] and
               not ($f0 shr (4*(x mod 2)))) or
               (Bits shl (4*(1 - x mod 2)));
            end;
            1:
            begin
              Index := h - 1 - y;
              Bits := PByteArray(SourceScanline[x])^[Index div 8];
              Bits := (Bits shr (7 - Index mod 8)) and $01;
              PByteArray(DestScanline[y])^[x div 8] :=
               (PByteArray(DestScanline[y])^[x div 8] and
               not ($80 shr (x mod 8))) or
               (Bits shl (7 - x mod 8));
            end;
          end;
        end;
      end;
      Width := hh;
      Height := ww;
    end;
    Picture.Graphic := NewBitmap;
  finally
    NewBitmap.Free;
  end;

  Stretch := srh;
  AutoSize := asz;

  Invalidate;

  Amended; // OnAmended CxgŔ
end;

end.
